;; NICOLA SKK  version 0.35 (Dec 25, 1997)
;; Copyright (C) 1997 Itsushi Minoura
;; based on SKK version 8.6
;;
;; SKK (Simple Kana to Kanji conversion program)
;; version 8.6 of May 17, 1995
;; Copyright (C) 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995
;; Masahiko Sato (masahiko@sato.riec.tohoku.ac.jp)

;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either versions 2, or (at your option)
;; any later version.

;; This program is distributed in the hope that it will be useful
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with SKK, see the file COPYING.  If not, write to the Free
;; Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;; Following people contributed modifications to skk.el:
;;	Masakazu Takahashi (masaka-t@ascii.co.jp)
;;	Tsugutomo Enami (enami@ptgd.sony.co.jp)
;;	MORI, Koichi (kmori@onsei2.rilp.m.u-tokyo.ac.jp)
;;	Jun-ichi Nakamura (nakamura@pluto.ai.kyutech.ac.jp)
;;	Kazuo Hirokawa (hirokawa@ricsgw.rics.co.jp)
;;	Wataru Matsui (matsui@atr-rd.atr.co.jp)
;;	Tomoyuki Hiro (hiro@momo.it.okayama-u.ac.jp)
;;	Masahiko Suzuki (suzmasa@sm.sony.co.jp)
;;	Katuya Tomioka (tomioka@culle.l.chiba-u.ac.jp)
;;	Kiyotaka Sakai (ksakai@mtl.t.u-tokyo.ac.jp)
;;	MIYOSHI Tsutomu (minkov@fuzzy.or.jp)
;;	Kazushi Marukawa (kazushi@kubota.co.jp)
;;	Ryoichi Hashimoto (gnu@ipri.go.jp)
;;	Hisao Kuroda (kuroda@msi.co.jp)
;;	Masahiro Doteguchi (xdote@rp.open.cs.fujitsu.co.jp)
;;	Naoki HAMADA (nao@mimo.jaist-east.ac.jp)
;;	Chikanobu Toyofuku (unbound@papaya.juice.or.jp)
;;	Shuji Ashizawa (ashizawa@zuken.co.jp)
;;	GUNJI Takao (gunji@lisa.lang.osaka-u.ac.jp)
;;	IIDA Yosiaki (iida@secom-sis.co.jp)
;;	Kimura Chikahiro (kimura@oa1.kb.nec.co.jp)
;;	Motohiko Mouri (mouri@jaist.ac.jp)
;;	Takeshi OHTANI (ohtani@iias.flab.fujitsu.co.jp)
;;	Haru Mizuno (mizu@cs3.cs.oki.co.jp)
;;	Mikio Nakajima (PBC01764@niftyserve.or.jp)
;;	Ż  (hisashi@rst.fujixerox.co.jp)

;; version 8.6 released 1995.5.17
;; version 7.18 released 1994.6.7
;; version 6.32 released 1993.4.24
;; version 5.30 released 1992.5.9
;; version 4.33 released 1991.5.9
;; version 3.47 released 1990.4.29
;; version 2.25 released 1989.4.15
;; version 1.13 released 1988.4.22

(defun skk-version ()
  (interactive)
  (if (interactive-p)
      (message "NICOLA SKK version %s of Dec 25, 1997" (skk-version))
    "8.6-n 0.35"))

(defun skk-server-version ()
  (interactive)
  (if (interactive-p)
      (message (skk-server-version))
    (if skk-server-host
	(let (v)
	  (set-buffer (get-buffer-create " *skkserv*"))
	  (erase-buffer)
	  (if (process-status "skkservd")
	      (progn
		(process-send-string "skkservd" "2")
		;; modified by Kiyotaka Sakai, 1994.9.9.
		(while (= (buffer-size) 0)
		  (accept-process-output))
		(setq v (buffer-substring (point-min) (1- (point-max))))
		(erase-buffer)
		(process-send-string "skkservd" "3")
		;; modified by Kiyotaka Sakai, 1994.9.9.
		(while (= (buffer-size) 0)
		  (accept-process-output))
		(format "SKK SERVER %s running on HOST %s." v
			(buffer-substring
			 (point-min)
			 (progn
			   (goto-char (point-min))
			   (search-forward ":")
			   (- (point) 1)))))
	    "SKK SERVER is not active."))
      "You are not using SKK SERVER.")))

;; variable declarations

(defvar skk-count-touroku 0)
(defvar skk-count-kakutei 0)

;(defvar j-kakutei-early nil)
; also exists skk-kakutei-early
(defvar j-kakutei-key nil)
; also exists skk-kakutei-key

(defvar skk-isearch-message nil
  "User must not change the value of this value.  This variable is used in
conjunction with skk-isearch.")

(defvar skk-mode-invoked nil
  "The value is t if skk-mode was invoked in this Emacs session.")

(defvar skk-mode nil
  "The value is t if skk-mode is currently invoked on the current buffer,
it is nil otherwise.")
(make-variable-buffer-local 'skk-mode)

(defvar skk-org-mode-line-format nil
  "Save mode-line-format of the current buffer.  This variable may also be
used to test if skk-mode has been called on the current buffer.")
(make-variable-buffer-local 'skk-org-mode-line-format)

(defvar skk-current-local-map nil
  "Save current-local-map")
(make-variable-buffer-local 'skk-current-local-map)

(defvar skk-vip-current-mode nil
  "Save vip-current-mode")
(make-variable-buffer-local 'skk-vip-current-mode)

;; Tsugutomo Enami suggested that the variables skk-map, skk-zenkaku-map and
;; skk-abbrev-map be initially set to nil, 1990.7.13.

(defvar skk-map nil
  "Keymap for kana mode.")
(make-variable-buffer-local 'skk-map)

(defvar skk-zenkaku-map nil
  "Keymap for zenkaku mode.")
(make-variable-buffer-local 'skk-zenkaku-map)

(defvar skk-abbrev-map nil
  "Keymap for abbrev input.")
(make-variable-buffer-local 'skk-abbrev-map)

(defvar skk-minibuff-map nil
  "Keymap used when reading string from minibuffer.")

(defvar skk-emacs-local-map nil
  "Original keymap for emacs mode.")
(make-variable-buffer-local 'skk-emacs-local-map)

(defvar skk-mode-line nil)
(make-variable-buffer-local 'skk-mode-line)

(defvar skk-prefix "")

(defvar skk-j-mode nil)
(make-variable-buffer-local 'skk-j-mode)

(defvar skk-henkan-on nil)
(make-variable-buffer-local 'skk-henkan-on)

(defvar skk-henkan-start-point (make-marker)
  "Henkan start point as a marker.")
(make-variable-buffer-local 'skk-henkan-start-point)

(defvar skk-henkan-end-point (make-marker)
  "Henkan end point as a marker.")
(make-variable-buffer-local 'skk-henkan-end-point)

(defvar skk-kana-start-point (make-marker)
  "Start point of a kana character as a marker.")

(defvar skk-okurigana nil
  "If t, it means that okurigana part of henkan word is being input.")
(make-variable-buffer-local 'skk-okurigana)

(defvar skk-okurigana-start-point (make-marker)
  "Start point of okurigana")
(make-variable-buffer-local 'skk-okurigana-start-point)

(defvar skk-okuri-char ""
  "The roman prefix for the okurigana part of henkan word as a string.")
(make-variable-buffer-local 'skk-okuri-char)

(defvar skk-henkan-count 0)
(make-variable-buffer-local 'skk-henkan-count)

(defvar skk-okuri-index-min 0)
(make-variable-buffer-local 'skk-okuri-index-min)

(defvar skk-okuri-index-max 0)
(make-variable-buffer-local 'skk-okuri-index-max)

(defvar skk-henkan-active nil)
(make-variable-buffer-local 'skk-henkan-active)

(defvar skk-katakana nil
  "t means katakana and nil means hirakana input.")
(make-variable-buffer-local 'skk-katakana)

(defvar skk-okuri-ari)
(make-variable-buffer-local 'skk-okuri-ari)

(defvar skk-henkan-key)
(make-variable-buffer-local 'skk-henkan-key)

(defvar skk-henkan-key2 nil)
(make-variable-buffer-local 'skk-henkan-key2)

(defvar skk-henkan-okurigana nil)
(make-variable-buffer-local 'skk-henkan-okurigana)

(defvar skk-henkan-vector (vector))
(make-variable-buffer-local 'skk-henkan-vector)

(defvar skk-jisyo-buffer-modified nil)

(defvar skk-current-search-prog-list nil)
(make-variable-buffer-local 'skk-current-search-prog-list)

(defvar skk-zenkaku)
(make-variable-buffer-local 'skk-zenkaku)

(defvar skk-abbrev nil)
(make-variable-buffer-local 'skk-abbrev)

(defvar skk-completion-word "")

(defvar skk-zenkaku-alist
  '((?  . "") 
    (?! . "")
    (?\" . "")
    (?# . "")
    (?$ . "")
    (?% . "")
    (?& . "")
    (?' . "")
    (?( . "")
    (?) . "")
    (?* . "")
    (?+ . "")
    (?, . "")
    (?- . "")
    (?. . "")
    (?/ . "")
    (?: . "")
    (?; . "")
    (?< . "")
    (?= . "")
    (?> . "")
    (?? . "")
    (?@ . "")
    (?[ . "")
    (?\\ . "")
    (?] . "")
    (?^ . "")
    (?_ . "")
    (?{ . "")
    (?| . "")
    (?} . "")
    (?~ . "")))

(defvar skk-num-list ()
  "list of numeric arguments obtained from skk-henkan-key.  for instance,
if skk-henkan-key is \"225ˤ\", skk-num-list will be set to
(\"2\" \"25\").")
(make-variable-buffer-local 'skk-num-list)

(defvar skk-search-key nil
  "string used as the search key for midashi search in jisyo buffer. the value
of this variable is set by using skk-henkan-key.  for instance, if skk-henkan-key
is \"225ˤ\", skk-search-key will be set to \"##ˤ\".")
(make-variable-buffer-local 'skk-search-key)

(defvar skk-okuri-ari-min nil)
(make-variable-buffer-local 'skk-okuri-ari-min)
(defvar skk-okuri-ari-max nil)
(make-variable-buffer-local 'skk-okuri-ari-max)
(defvar skk-okuri-nasi-min nil)
(make-variable-buffer-local 'skk-okuri-nasi-min)

;; variables for the function input-by-code-or-menu

(defvar skk-code-n1-min 161)
(defvar skk-code-n1-max 244)
(defvar skk-code-n2-min 161)
(defvar skk-code-n2-max 254)
(defvar skk-code-null 128)
(defvar skk-input-by-code-or-menu-jump-default skk-code-n1-min)

;; The following variable was introduced at the suggestion of Masakazu
;; Takahashi, 1991.10.1.

(defvar skk-remote-shell-program
  (or (getenv "REMOTESHELL")
      (cond
       ((eq system-type 'berkeley-unix) "/usr/ucb/rsh")
       ((eq system-type 'usg-unix-v)
	(if (file-exists-p "/usr/ucb/remsh") "/usr/ucb/remsh" "/bin/rsh"))
       ((eq system-type 'hpux) "/usr/bin/remsh")
       ((eq system-type 'EWS-UX/V) "/usr/ucb/remsh")
       ((eq system-type 'pcux) "/usr/bin/rcmd")
       (t "rsh"))))

;; The following variable was introduced at the suggestion of Masahiko
;; Suzuki, 1992.7.13.
;; modified by Mikio Nakajima, 1994.12.4
(defvar skk-init-file (if (eq system-type 'ms-dos) "~/_skk" "~/.skk")
  "*The name of the skk initialization file.")

;; The following variable was introduced at the suggestion of Ryoichi
;; Hashimoto, 1993.4.1.

(defvar skk-special-midashi-char-list '(?> ?< ??)
  "*List of chars used to spicify pre/post-fixes.")

;; The following variable was introduced by Tsugutomo Enami, 1994.5.30.

(defvar skk-henkan-okuri-strictly nil
  "If non-nil, okurigana should also be matched.")

;; The following variable was introduced by Kiyotaka Sakai, 1994.6.14.

(defconst skk-kanji-len (length ""))

;; constants

;; Customization of these constants cannot be done in .emacs file.  This
;; should be done in .skk file or by using skk-mode-hook.

;; We are using `defconst' rather than `defvar' here for the following
;; reason:  The SKK tutorial program, which is intended for the beginners,
;; must be run on a vanilla SKK.  To achieve this, the tutorial program
;; loads SKK (even if it has been loaded already) and undoes the customization
;; which might have been done by the user.  (Note that `defconst' always sets
;; a new value, while `defvar' does that only when the value is unbound when
;; `defvar' is executed.)

(defconst skk-kakutei-jisyo nil
  "*Name of a sorted jisyo file.  If non-nil, the file will be read in a
buffer and will be used to compute henkan candidates.  The file should be
such that each yomi has exactly one candidate.  This file is used by the
function skk-search-kakutei-jisyo-file.")

(defconst skk-initial-search-jisyo nil
  "*Name of a sorted jisyo file.  If non-nil, the file will be read in a
buffer and will be used to compute henkan candidates.  Normally, this
file will be searched before the user's private jisyo.")

(defconst skk-large-jisyo nil
  "*Name of a sorted jisyo file.  If non-nil, the file will be read in a
buffer and will be used to compute henkan candidates.  Normally, the
file be searched after the user's private jisyo.")

(defconst skk-aux-large-jisyo nil
  "*Name of a sorted jisyo file.  If non-nil, the file will be used when
skk server is not active.")

(defconst skk-search-prog-list
  '(
    (skk-search-kakutei-jisyo-file skk-kakutei-jisyo 10000 t)
    (skk-search-jisyo-file skk-initial-search-jisyo 10000 t)
    (skk-search-jisyo-file skk-jisyo 0 t)
    (skk-okuri-search)
    (skk-search-jisyo-file skk-large-jisyo 10000)
    (skk-search-server skk-aux-large-jisyo 10000)
    )
  "*List of sexps such that each element, when evaluated, returns a vector
of henkan candidates for skk-henkan-key.")

;; modified by Mikio Nakajima, 1994.12.4
(defconst skk-jisyo (if (eq system-type 'ms-dos) "~/_skk-jisyo" "~/.skk-jisyo")
  "*The name of the skk jisyo file.")

;; modified by Mikio Nakajima, 1994.12.4
(defconst skk-backup-jisyo
  (if (eq system-type 'ms-dos) "~/_skk-jisyo.BAK" "~/.skk-jisyo.BAK")
  "*The name of the skk backup jisyo file.")

;; suggested by Koichi Mori, 1990.8.20
(defconst skk-jisyo-code nil
  "*If non-nil, it is used as the value of kanji-fileio-code for the jisyo
buffer.")

;; modified by Mikio Nakajima, 1994.12.4
(defconst skk-record-file
  (if (eq system-type 'ms-dos) "~/_skk-record" "~/.skk-record")
  "*The name of the skk record file.")

(defconst skk-kakutei-key "\C-j"
  "*Key sequence that will invoke the command skk-kakutei.")

;; suggested by Koichi Mori, 1991.1.27.
(defconst skk-date-ad t
  "*If non-nil, skk-date is in A.D.  If nil, it is in Nengo (Heisei).")

;; suggested by Koichi Mori, 1991.1.27.
(defconst skk-number-style 1
  "*If nil or 0, numbers in skk-date are in Hankaku. If t or 1, in Zenkaku.
Otherwise Kanji.")

(defconst skk-keep-record t
  "*If t, skk will keep record of the success rate of kana to kanji conversion
etc. in the file ~/.skk-record.")

(defconst skk-use-vip nil
  "*If t, skk will assume that the user will use vip-mode at the same time.")

(defvar skk-use-nicola nil
  "*If t, skk will assume that the user will use NICOLA keymap.")

(defconst skk-auto-okuri-process nil
  "*If t, skk automatically recognizes okuri-gana part.  For instance, you
can just type `Uresii ' and it will be converted as you expect. This
behavior is available only if SKK-PROCESS-OKURI-EARLY is nil.")

(defconst skk-process-okuri-early nil
  "*If t, skk will start kana to kanji conversion when it reads the first
roman character for okurigana, if nil then kana to kanji conversion will
start only when it reads a complete roman representation for a kana
character.")

;; introduced by Wataru Matsui 1991.8.19
(defconst skk-egg-like-newline nil
  "*If non-nil, no newline is inserted in any henkan mode.")

(defvar skk-kakutei-early t
  "*If t, the values of J-HENKAN-ACTIVE is also t, and SKK-PROCESS-OKURI-EARLY
is nil, then skk will kakutei the current candidate when j-kana-input is
called.")

;; the following three variables were introduced by Kiyotaka Sakai, 1994.7.3.

(defconst skk-henkan-show-candidates-keys '(?a ?s ?d ?f ?j ?k ?l)
  "*Chars when you select candidates by menu. This list should contain 7
characters.")

(defconst skk-input-by-code-menu-keys1 '(?a ?s ?d ?f ?g ?h ?q ?w ?e ?r ?t ?y)
  "*Chars when you input JIS characters by menu at first. This list should
contain 12 characters.")

(defconst skk-input-by-code-menu-keys2
  '(?a ?s ?d ?f ?g ?h ?j ?k ?l ?q ?w ?e ?r ?t ?y ?u)
  "*Chars when you input JIS characters by menu in the second. This list
should contain 16 characters.")

(defconst skk-previous-candidate-char ?x
  "Key to select previous candidate at Henkan")

(defconst skk-mode-string "--SKK:"
  "*The value of this constant is used in the mode line when skk is in ascii
mode.")

(defconst skk-hirakana-mode-string "--"
  "*The value of this constant is used in the mode line when skk is in hirakana
mode.")

(defconst skk-katakana-mode-string "--"
  "*The value of this constant is used in the mode line when skk is in katakana
mode.")

(defconst skk-zenei-mode-string "--"
  "*The value of this constant is used in the mode line when skk is in zenei
mode.")

(defconst skk-echo t
  "*If T, echoes prefix for kana characters.")

(defconst skk-server-host (getenv "SKKSERVER")
  "*Name of the host running SKK Jisyo Server")

(defconst skk-serv (getenv "SKKSERV")
  "*Name of the SKK Jisyo Server program")

;; introduced by Kiyotaka Sakai 1993.7.28
(defconst skk-server-list nil
  "*List of the SKK Jisyo Server")

(defconst skk-portnum nil
  "*If the value is non-nil, it must be the PORTNUM defined in skkserv.h")

(defconst skk-report-server-response nil
  "*When SKK sends a request to SKK SERVER, SKK waits for the process output
by repeatedly executing the accept-process-output function.  If this constant
is t, then SKK will report the number of times the function is called.")

(defconst skk-use-numeric-conversion t
  "*If t, convert numerals in the henkan word appropriately.")

;(defconst skk-nemacs-v2 (not (boundp 'self-insert-after-hook))
;  "If t, it means that skk is running under Nemacs version 2 (very old
;Nemacs.")

(defconst skk-mule (and (boundp 'MULE) MULE)
  "If t, it means that skk is running under Mule.")

;; introduced by Kiyotaka Sakai 1994.1.10
;; modified by Mikio Nakajima, 1994.12.4
;; modified by Ż  , 1995.4.10
;; modified by Mikio Nakajima, 1995.4.11
(defconst skk-emacs19 (string-match "^19" emacs-version)
  "If non-nil, it means that skk is running under emacs-19.")

(defconst skk-dabbrev-like-completion nil
  "*If t, completion will be done like dabbrev-expand.  namely, if one tries
completion successively, completion will be done for the initial completion
word rather than the most recently completed word.")

(defconst skk-delete-implies-kakutei t
  "*This variable is use to control the behavior of the function
skk-delete-backward-char when it is called with skk-henkan-active being t.
If the variable is non-nil, the previous charater will be deleted and
skk-kakutei will be called.  If nil, skk-previous-candidate will be called
instead.")

(defconst skk-delete-okuri-when-quit nil)

(defconst skk-num-type-list
  '((?0 . identity) ; modified by Mikio Nakajima, 1995.4.19
    (?1 . skk-zenkaku-num-str)
    (?2 . skk-kanji-num-str)
    (?3 . skk-kanji-num-str2)
    (?9 . skk-shogi-num-str))
  "*association list of type-function pairs used in the conversion of numeric
arguments in henkan key.")

(defconst skk-char-type-vector
  [0 0 0 0 0 0 0 0
   5 0 0 0 0 0 0 0
   0 0 0 0 0 0 0 0
   0 0 0 0 0 0 0 0
   0 0 0 0 0 0 0 0
   0 0 0 0 0 0 0 0
   0 0 0 0 0 0 0 0
   0 0 0 0 0 0 0 0
   0 4 4 4 4 4 4 4
   4 4 4 4 0 4 4 4
   4 0 4 4 4 4 4 4
   0 4 4 0 0 0 0 0
   0 3 1 1 1 3 1 1
   1 3 1 1 0 1 2 3
   1 0 1 1 1 3 1 1
   2 1 1 0 0 0 0 5]
  "*char type is interpreted as follows.
0 exit rom-kana conversion (not used at present)
1 consonant that can be part of sokuon
2 other consonants (n, x)
3 vowel
4 bound to skk-set-henkan-point in skk-mode
5 delete prefix")

; moved to skk-roma.el
;(defconst skk-kana-rom-vector

(defconst skk-prefix-list
  '("by" "ch" "cy" "dh" "dy" "fy" "gy" "hy" "jy" "ky" "my" "py" "ry" "sh" "sy"
    "th" "ts" "ty" "xk" "xt" "xts" "xw" "xy" "zy"))

(defconst skk-rom-kana-rule-list
  '(("nn" nil ("" . ""))
    ("n'" nil ("" . ""))))

(defconst skk-rom-kana-rule-tree nil)

(defconst skk-input-vector
  [nil  nil  nil  nil  nil  nil  nil  nil
   nil  nil  nil  nil  nil  nil  nil  nil 
   nil  nil  nil  nil  nil  nil  nil  nil 
   nil  nil  nil  nil  nil  nil  nil  nil 
   nil  "" nil  nil  nil  nil  nil  nil
   nil  nil  nil  nil  "" "" "" nil
   nil  nil  nil  nil  nil  nil  nil  nil 
   nil  nil  "" "" nil  nil  nil  ""
   nil  nil  nil  nil  nil  nil  nil  nil 
   nil  nil  nil  nil  nil  nil  nil  nil 
   nil  nil  nil  nil  nil  nil  nil  nil 
   nil  nil  nil  "" nil  "" nil  nil
   nil  nil  nil  nil  nil  nil  nil  nil 
   nil  nil  nil  nil  nil  nil  nil  nil 
   nil  nil  nil  nil  nil  nil  nil  nil 
   nil  nil  nil  nil  nil  nil  nil  nil]
  "*Translation table for j-self inserting characters.")

(defconst skk-zenkaku-vector
  [nil  nil  nil  nil  nil  nil  nil  nil
   nil  nil  nil  nil  nil  nil  nil  nil 
   nil  nil  nil  nil  nil  nil  nil  nil 
   nil  nil  nil  nil  nil  nil  nil  nil 
   ""  "" "" "" "" "" "" ""
   "" "" "" "" "" "" "" ""
   "" "" "" "" "" "" "" ""
   "" "" "" "" "" "" "" ""
   "" "" "" "" "" "" "" ""
   "" "" "" "" "" "" "" ""
   "" "" "" "" "" "" "" ""
   "" "" "" "" "" "" "" ""
   "" "" "" "" "" "" "" ""
   "" "" "" "" "" "" "" ""
   "" "" "" "" "" "" "" ""
   "" "" "" "" "" "" "" nil])

;; utilities

;; modified by Mikio Nakajima, 1995.4.10
(if (fboundp 'member)
    (fset 'skk-member 'member)
  (defun skk-member (x l)
    "check if X is a member of L, where string= is used to compare elements
of L against X"
    (catch 'found
      (while l
        (if (string= x (car l))
            (throw 'found t)
          (setq l (cdr l)) )))))

;; modified by Mikio Nakajima, 1995.4.10
(if (fboundp 'assoc)
    (defun skk-assoc (key a-list)
      (cdr (assoc key a-list)) )
  (defun skk-assoc (key a-list)
    (let ((list a-list) (cont t) (val nil))
      (while cont
	(if (null list)
	    (setq cont nil)
	  (let ((key2 (car (car list))))
	    (if (string= key key2)
		(setq cont nil
		      val (cdr (car list)))
	      (setq list (cdr list))))))
      val)))

;; added by Kiyotak Sakai, 1994.11.8.
(cond (skk-emacs19
       (fset 'skk-read-char 'read-char-exclusive))
      (t
       (fset 'skk-read-char 'read-char)))

(defun skk-change-mode-line (string)
  (setq skk-mode-line string)
  (set-buffer-modified-p (buffer-modified-p)))

(defun skk-today ()
  "Insert current date at point in Kanji."
  (interactive)
  (insert (skk-date)))

;; modified by Koichi Mori, 1991.1.17

(defun skk-date (&optional date-ad number-style)
  (let* ((skk-date-ad (or date-ad skk-date-ad))
	 (skk-number-style (or number-style skk-number-style))
	 (str (current-time-string))
	 (y (- (string-to-int (substring str 20 24)) 1988))
	 (year (if skk-date-ad
		   (skk-num (substring str 20 24))
		 (if (= y 1) "" (skk-num (int-to-string y)))))
	 (mon (substring str 4 7))
	 (month
	  (skk-num
	   (cdr (assoc mon
		       '(("Jan" . "1") ("Feb" . "2") ("Mar" . "3")
			 ("Apr" . "4") ("May" . "5") ("Jun" . "6")
			 ("Jul" . "7") ("Aug" . "8") ("Sep" . "9")
			 ("Oct" . "10") ("Nov" . "11") ("Dec" . "12"))))))
	 (day (skk-num (substring str 8 10)))
	 (dw (substring str 0 3))
	 (day-of-week
	  (cdr (assoc dw
		      '(("Sun" . "") ("Mon" . "") ("Tue" . "")
			("Wed" . "") ("Thu" . "") ("Fri" . "")
			("Sat" . "")))))
	 )
    (concat (if skk-date-ad "" "ʿ") year "ǯ"
	    month "" day "" "\(" day-of-week "\)")))

;; modified by Masakazu Takahashi, 1991.3.27
;; modified by Koichi Mori, 1991.1.17

(defun skk-num (str)
  "convert a number string to other style according to SKK-NUMBER-STYLE"
  (mapconcat (function skk-num1) str ""))

(defun skk-num1 (c)
  "convert a number character to other style according to SKK-NUMBER-STYLE"
  (cond ((or (null skk-number-style) (eq skk-number-style 0))
	 (cdr (assq c
		    '((?0 . "0") (?1 . "1") (?2 . "2") (?3 . "3")
		      (?4 . "4") (?5 . "5") (?6 . "6") (?7 . "7")
		      (?8 . "8") (?9 . "9") (?  . "")))))
	((or (eq skk-number-style t) (eq skk-number-style 1))
	 (cdr (assq c
		    '((?0 . "") (?1 . "") (?2 . "") (?3 . "")
		      (?4 . "") (?5 . "") (?6 . "") (?7 . "")
		      (?8 . "") (?9 . "") (?  . "")))))
	(t
	 (cdr (assq c
		    '((?0 . "") (?1 . "") (?2 . "") (?3 . "")
		      (?4 . "") (?5 . "") (?6 . "ϻ") (?7 . "")
		      (?8 . "Ȭ") (?9 . "") (?  . "")))))))

;; modified by Kazuo Hirokawa, 1991.11.18.
;; modified by Kiyotaka Sakai, 1994.1.10.

(defun skk-convert-to-vector (map)
  "convert a map in list form to a map in vector form."
  (if (not (or (vectorp map) skk-emacs19))
      (let ((new-map (make-keymap)) (l (cdr map)) def)
	(while l
	  (setq def (cdr (car l)))
	  (aset new-map (car (car l)) (if (keymapp def)
                      (copy-keymap def)
		      def))
	  (setq l (cdr l)))
	new-map)
    ;; modified by Tsugutomo Enami, 1990.7.9
    (copy-keymap map)))

;; the following function was introduced at the suggestion of
;; Tsugutomo Enami, 1993.4.7.

(defun skk-in-minibuffer-p ()
  "check if the minibuffer is currently selected."
  (eq (selected-window) (minibuffer-window)))

;; modified by Tsugutomo Enami, 1994.7.9.

(defun skk-do-auto-fill ()
  (and auto-fill-function (funcall auto-fill-function)))

;(defun skk-do-auto-fill ()
;  (if skk-emacs19
;      ;; this is enough emacs19 do-auto-fill.
;      (and auto-fill-function (funcall auto-fill-function))
;    (and auto-fill-hook
;	 (let* ((c (current-column)) (cont (> c fill-column)))
;	   (while cont
;	     (run-hooks 'auto-fill-hook)
;	     ;; if current-column doesn't change after do-auto-fill,
;	     ;; we exit from the while loop by setting cont to be nil.
;	     ;; also, it is necessary that current-column >
;	     ;; fill-column to continue the loop.
;	     (setq cont (and (< (current-column) c)
;			     (> (current-column) fill-column)))
;	     (setq c (current-column)))))))

(defun skk-auto-fill-mode (arg)
  (interactive "P")
  (let ((auto-fill
	 ;; modified by Tsugutomo Enami, 1994.7.9.
	 (cond ((null arg) (not auto-fill-function))
	       ((> (prefix-numeric-value arg) 0) t)
	       (t nil))))
    (auto-fill-mode (if auto-fill 1 -1))
    (or skk-mode (skk-mode 1))
    (run-hooks 'skk-auto-fill-mode-hook)))

;;; kana inserting functions

;moved to skk-roma.el
;(defun skk-insert (table)

;; the following function relies on the dynamic variable vip-ovwrt-limit
;; used in vip version 4.
;; this style of coding should be avoided if possible.

(defun skk-ovwrt-len (len)
  (if (and skk-use-vip (boundp 'vip-ovwrt-limit))
      (min (- vip-ovwrt-limit (point))
	   (- (save-excursion (end-of-line) (point)) (point))
	   len))
    ;; modified by Kiyotaka Sakai, 1994.6.14.
  (min (string-width
	(buffer-substring (point) (save-excursion (end-of-line) (point))))
       len))

(defun skk-insert-str (str)
  "Insert STR and, if necessary, call self-insert-after-hook, and take care of
overwrite-mode"
  (insert str)
  (or skk-henkan-on
      (progn
	(if self-insert-after-hook
	    (funcall self-insert-after-hook (- (point) (length str)) (point)))
	;; (boundp 'vip-ovwrt-limit) means that this function is within the
	;; dynamic scope of vip-overwrite-execute
	(if (or overwrite-mode (boundp 'vip-ovwrt-limit))
	    ;; modified by Kiyotaka Sakai, 1994.6.14.
	    (skk-del-char-with-pad (skk-ovwrt-len (string-width str)))))))

(defun skk-del-char-with-pad (length)
  "Delete exactly LENGTH width, by inserting a space at the end,
if necessary, for adjustment."
  ;; modified by Kiyotaka Sakai, 1994.6.14.
  (let ((p (point)) (len 0))
    (while (< len length)
      (forward-char 1)
      (setq len (string-width (buffer-substring (point) p))))
    (delete-region p (point))
    (or (= length len)
	(progn
	  (insert " ")
	  (backward-char 1)))))

;moved to skk-roma.el
;(defun skk-set-okurigana ()

;moved to skk-roma.el
;(defun skk-insert-a ()
;(defun skk-insert-i ()
;(defun skk-insert-u ()
;(defun skk-insert-e ()
;(defun skk-insert-o ()


(defun skk-erase-prefix ()
  "erase skk-prefix characters if SKK-ECHO is on."
  (if skk-echo
      (delete-region skk-kana-start-point (point))))

(defun skk-insert-prefix (&optional char)
  "insert skk-prefix if SKK-ECHO is on"
  (if skk-echo (insert (or char skk-prefix))))

;; other inserting functions

;(defun skk-insert-comma (count)

;(defun skk-insert-period (count)

;; kana input by romaji to kana conversion

;(defun skk-kana-input ()

;;; convert skk-rom-kana-rule-list to skk-rom-kana-rule-tree.
;;; The rule tree follows the following syntax:
;;; <tree> ::= ((<char> . <tree>) . <tree>) | nil
;;; <item> ::= (<char> . <tree>)

;(defun j-compile-rule-list (l)
;(defun skk-add-rule (rule tree)
;(defun skk-add-rule-main (char rest body tree)
;(defun skk-make-rule-tree (char rest body)
;(defun skk-search-tree (char tree)
;(defun skk-assoc-rule (key)
;(defun skk-assoc-tree (key tree)

;; mode setup

(defun skk-mode (&optional arg)
  "SKK mode enables input of Japanese texts without affecting the
functionality of the original mode. With negative ARG, exits from SKK mode."
  (interactive "P")
  (setq skk-mode
	(if skk-org-mode-line-format
	    (cond ((null arg) (not skk-mode))
		  ((> (prefix-numeric-value arg) 0) t)
		  (t nil))
	  ;; if skk-mode has not been called in this buffer, always
	  ;; enter skk-mode
	  t))
  (if (and (skk-in-minibuffer-p) (boundp 'vip-current-mode))
      (setq vip-read-string-hook
	    '(lambda ()
	       (define-key minibuffer-local-map skk-kakutei-key 'skk-kakutei)
	       (define-key minibuffer-local-map "\C-m" 'skk-newline))))
  (if (not skk-mode)
      ;; exit skk-mode
      (progn
	(if skk-use-vip (vip-change-mode-to-insert))
	;; Tsugutomo Enami added the following line, 1990.7.13
	(let ((skk-mode t)) (skk-kakutei))
	;; the following line modified by Tsugutomo Enami, 1990.7.13
	(setq mode-line-format skk-org-mode-line-format)
	(use-local-map skk-current-local-map)
	(set-buffer-modified-p (buffer-modified-p)))
    ;; enter skk-mode
    (if (not skk-mode-invoked)
	;; enter skk-mode for the first time in this session
	(progn
	  ;; for nicola
	  (load skk-init-file t)
	  (if skk-use-nicola (load "skk-nicola" nil) (load "skk-roma" nil))
	  (setq skk-mode-invoked t)
	  ;; modified by Tsugutomo Enami, 1990.8.26
	  ;; modified by Masahiko Suzuki, 1992.7.13
;	  (setq j-kakutei-early
;		(and skk-kakutei-early (not skk-process-okuri-early)))
	  (if skk-keep-record
	      (skk-create-file
	       skk-record-file
	       "SKK Ͽѥեޤ"))
	  (or (file-exists-p skk-jisyo)
	      (skk-create-file
	       skk-jisyo
	       "SKK ζޤ"))
	  (skk-get-file-buffer skk-jisyo t)
	  (setq skk-jisyo-buffer-modified nil)
	  ;; added by Kiyotaka Sakai, 1994.6.14.
	  (or (fboundp 'string-width)
	      (fset 'string-width (symbol-function 'length)))
	  (if skk-use-vip
	      (progn
		;; we should be able to use (require 'vip) eventually.
		(if (not (boundp 'vip-current-mode)) (load "vip"))
		;; check vip's version.  this modification will not be
		;; necessary for vip4.x.
		(if (string= (vip-version)
			     "VIP version 3.5 of September 15, 1987")
		    (progn
		      (message "")
		      (fset 'vip-change-mode 'vip-ch-mode))))) ))
    (if (or (not skk-org-mode-line-format) (skk-in-minibuffer-p))
	;; enter skk-mode for the first time in this buffer or the buffer
	;; is the minibuffer
	(let (map)
	  (if (and skk-use-vip (not (skk-in-minibuffer-p)))
	      (let ((skk-mode nil)) (vip-change-mode-to-insert)))
	  (setq map (if (skk-in-minibuffer-p) minibuffer-local-map
		       (current-local-map)))
	  ;; save current mode
	  ;; modified by Tsugutomo Enami, 1990.7.13.
	  (setq skk-org-mode-line-format mode-line-format
		skk-current-local-map (if map (copy-keymap map) nil))
	  ;; modified at the suggestion of Masakazu Takahashi, 1990.7.8
	  (setq skk-emacs-local-map
		(if map (copy-keymap map) (make-sparse-keymap)))
	  (define-key skk-emacs-local-map skk-kakutei-key 'skk-kakutei)
	  (skk-setup-map)
	  (skk-setup-zenkaku-map)
	  (skk-setup-abbrev-map)
	  (run-hooks 'skk-mode-hook) )
      (if (and skk-use-vip (not (skk-in-minibuffer-p)))
	  (let ((skk-mode nil)) (vip-change-mode-to-insert))))
    (setq skk-j-mode t
	  skk-katakana nil)
    (use-local-map skk-map)
    (define-key minibuffer-local-map
      (default-value 'skk-kakutei-key) 'skk-kakutei)
    (define-key minibuffer-local-completion-map
      (default-value 'skk-kakutei-key) 'skk-kakutei)
    (define-key minibuffer-local-ns-map
      (default-value 'skk-kakutei-key) 'skk-kakutei)
    (define-key minibuffer-local-map "\C-m" 'skk-newline)
    (define-key minibuffer-local-completion-map "\C-m" 'skk-newline)
    (define-key minibuffer-local-ns-map "\C-m" 'skk-newline)
;    (if skk-use-nicola ;; Ѥ٤ (skk-newline ꤷƤѹ)
;	(progn  ;; do these minibuffers require lshift and rshift???
;	  (skk-nic-select-hiragana)
;	  (use-local-map skk-map)
;	  (define-key minibuffer-local-map "\C-m" 'skk-newline)
;	  (define-key minibuffer-local-completion-map "\C-m" 'skk-newline)
;	  (define-key minibuffer-local-ns-map "\C-m" 'skk-newline) ))
    (setq mode-line-format
	  (cons "" (cons 'skk-mode-line (cdr skk-org-mode-line-format))))
    (skk-change-mode-line skk-hirakana-mode-string)) )

;; The following function is contributed by Tsugutomo Enami, 1992.5.6.
;; modified by Kiyotaka Sakai, 1993.7.9
;; modified by Kiyotaka Sakai, 1993.7.28

(defun skk-set-jisyo-code (code)
  (cond ((stringp code)
	 (if skk-mule
	     (set-file-coding-system
	      (cdr (assoc code '(("euc" . *euc-japan*) ("ujis" . *euc-japan*)
				 ("sjis". *sjis*) ("jis" . *junet*)))))
	   (setq kanji-fileio-code
		 (cdr (assoc code '(("euc"  . 0) ("ujis"  . 0)
				    ("sjis" . 1) ("jis"  . 2)))))))
	(code (if skk-mule
		  (set-file-coding-system code)
		(setq kanji-fileio-code code)))))

(defun skk-setup-map ()
  (setq skk-map (skk-convert-to-vector skk-emacs-local-map))
  (skk-define-map skk-map))

(defun skk-setup-minibuff-map ()
  (setq skk-minibuff-map (skk-convert-to-vector minibuffer-local-map))
  (skk-define-map skk-minibuff-map t))

; moved to skk-roma.el
;(defun skk-define-map (map &optional minibuff)

;;; modified by Masahiko Sato, 1991.4.6
;;; modified by Masakazu Takahashi, 1990.5.11

(defun skk-setup-zenkaku-map ()
  (setq skk-zenkaku-map (skk-convert-to-vector skk-emacs-local-map))
  (let ((i 0))
    (while (< i 128)
      (if (aref skk-zenkaku-vector i)
	  (define-key skk-zenkaku-map (char-to-string i) 'skk-zenkaku-insert) )
      (setq i (1+ i)))))

; moved to skk-roma.el
;(defun skk-setup-abbrev-map ()

;; modified by Kazuo Hirokawa, 1991.11.18.

(defun skk-self-insert (arg)
  (interactive "P")
  (let ((str (aref skk-input-vector last-command-char)))
    (if str
	(let ((count (prefix-numeric-value arg)))
	  (while (> count 0)
	    (skk-insert-str str)
	    (setq count (1- count))))
      (skk-emulate-original-map arg))
    (if skk-henkan-active (skk-kakutei))))

(defun skk-zenkaku-insert (count)
  (interactive "p")
  (let* ((str (aref skk-zenkaku-vector last-command-char))
	 (len (length str)))
    (while (> count 0)
      (skk-insert-str str)
      (setq count (1- count)))))

(defun skk-zenkaku-self-insert (count)
  (interactive "p")
  (while (> count 0)
    ;; modified by Kazuo Hirokawa, 1993.7.7
    (skk-insert-str (skk-char-to-string 163 (+ last-command-char 128)))
    (setq count (1- count))))

(defun skk-mode-off ()
  "return to old ascii mode."
  (interactive)
  (skk-kakutei)
  (setq skk-j-mode nil
	skk-prefix ""
	skk-zenkaku nil)
  (use-local-map skk-emacs-local-map)
  (skk-change-mode-line skk-mode-string))

(defun skk-mode-off-in-minibuff ()
  "return to old ascii mode in the minibuffer."
  (interactive)
  (skk-kakutei)
  (setq skk-j-mode nil
	skk-prefix ""
	skk-zenkaku nil)
  (use-local-map minibuffer-local-map))

(defun skk-zenkaku-eiji ()
  "zenkaku-eiji input"
  (interactive)
  (skk-kakutei)
  (setq skk-j-mode nil
	skk-prefix ""
	skk-zenkaku t)
  (use-local-map skk-zenkaku-map)
  (skk-change-mode-line skk-zenei-mode-string))

(defun skk-abbrev-input ()
  (interactive)
  (if (and skk-henkan-on (not skk-henkan-active))
      (error "ˢ⡼ɤäƤޤ"))
  (skk-kakutei)
  (skk-set-henkan-point-subr)
  (use-local-map skk-abbrev-map)
  ;; added
  (skk-change-mode-line skk-mode-string)
  (setq skk-abbrev t))

;; vip related functions

(defun vip-ch-mode (new-mode)
  "(NEW-MODE)  Change mode to NEW-MODE.  NEW-MODE is either emacs-mode,
vi-mode, or insert-mode."
  (if (skk-in-minibuffer-p)
      (error "Can't change mode in minibuffer!")
    (or (eq new-mode vip-current-mode)
	(progn
	  (cond ((eq new-mode 'vi-mode)
		 (if (eq vip-current-mode 'insert-mode)
		     (progn
		       (if (and skk-mode skk-j-mode) (skk-kakutei))
		       (vip-copy-region-as-kill (point) vip-insert-point)
		       (vip-repeat-insert-command))
		   (setq vip-emacs-local-map (current-local-map)
			 vip-emacs-mode-line-buffer-identification
			 mode-line-buffer-identification
			 vip-insert-local-map (vip-copy-keymap
					       (current-local-map))))
		 (vip-change-mode-line "Vi:   ")
		 (if skk-mode (skk-change-mode-line skk-mode-string))
		 (use-local-map vip-mode-map))
		((eq new-mode 'insert-mode)
		 (move-marker vip-insert-point (point))
		 (if (eq vip-current-mode 'emacs-mode)
		     (setq vip-emacs-local-map (current-local-map)
			   vip-emacs-mode-line-buffer-identification
			   mode-line-buffer-identification
			   vip-insert-local-map (vip-copy-keymap
						 (current-local-map))))
		 (vip-change-mode-line "Insert")
		 (if skk-mode
		     (skk-change-mode-line
		      (if skk-j-mode (if skk-katakana skk-katakana-mode-string
				   skk-hirakana-mode-string)
			(if skk-zenkaku skk-zenei-mode-string skk-mode-string))))
		 (if skk-mode
		     (if skk-j-mode
			 (use-local-map skk-map)
		       (if skk-zenkaku
			   (use-local-map skk-zenkaku-map)
			 (use-local-map vip-insert-local-map)
			 (local-set-key skk-kakutei-key 'skk-kakutei)))
		   (use-local-map vip-insert-local-map))
		 (local-set-key "\e" 'vip-change-mode-to-vi)
		 (local-set-key "\C-z" 'vip-ESC)
		 (local-set-key "\C-h"
				(if vip-help-in-insert-mode 'help-command
				  'skk-delete-backward-char))
		 (local-set-key "\C-w"
				'vip-delete-backward-word))
		((eq new-mode 'emacs-mode) 
		 (vip-change-mode-line "Emacs:")
		 (if skk-mode (skk-change-mode-line skk-mode-string))
		 (use-local-map vip-emacs-local-map)))
	  (setq vip-current-mode new-mode)
	  (vip-refresh-mode-line)))))

(if (not (fboundp 'skk-save-buffers-kill-emacs))
    (fset 'skk-save-buffers-kill-emacs
	  (symbol-function 'save-buffers-kill-emacs)))

(defun save-buffers-kill-emacs (&optional query)
  "Save SKK jisyo buffer, offer to save each buffer, then kill this Emacs fork.
With prefix arg, silently save all file-visiting buffers, then kill."
  (interactive "P")
  (skk-save-jisyo)
  ;; modified at the suggestion of Masahiko Suzuki to check the value of
  ;; SKK-SERVER-HOST, 1992.7.13.
  ;; modified by Mikio Nakajima, 1995.4.15 
  (or (eq system-type 'ms-dos)
      (if (and skk-server-host (process-status "skkservd"))
	  (process-send-string "skkservd" "0")) ;; disconnect server
      ;; modified at the suggestion of Tsugutomo Enami, 1995.2.3
      (accept-process-output (get-process "skkservd")) )
  (skk-save-buffers-kill-emacs query))

(defun skk-kill-emacs-without-saving-jisyo (&optional query)
  "Kill Emacs without saving jisyo."
  (interactive "P")
  (if (yes-or-no-p "Do you really wish to kill emacs without saving Jisyo? ")
      (progn
	(let ((buff (get-file-buffer skk-jisyo)))
	  (if buff (kill-buffer buff)))
	;; modified at the suggestion of Masahiko Suzuki to check the value of
	;; skk-server-host, 1992.7.13.
        ;; modified by Mikio Nakajima, 1995.4.9
        (or (eq system-type 'ms-dos)
	    (if (and skk-server-host (process-status "skkservd"))
		(process-send-string "skkservd" "0")) ;; disconnect server
	    ;; modified at the suggestion of Tsugutomo Enami, 1995.2.3
            (accept-process-output (get-process "skkservd")) )
	(skk-save-buffers-kill-emacs query))))

(defun skk-save-jisyo ()
  "Save jisyo buffer into jisyo file."
  (interactive)
  (if (not skk-jisyo-buffer-modified)
      (message "No need to save Jisyo.")
    ;; check if the header lines for the two jisyo buffers are ok.
    ;; error corrected by Masakazu Takahashi, 1992.1.26.
    (save-excursion
      (set-buffer (get-file-buffer skk-jisyo))
      ;; modified by Tsugutomo Enami, 1992.5.6
      ;; set kanji-fileio-code appropriately
      (skk-set-jisyo-code skk-jisyo-code)
      (goto-char (point-min))
      (or (string=
	   (buffer-substring
	    (point)
	    (progn (end-of-line) (point)))
	   ";; okuri-ari entries.")
	  (search-forward "\n;; okuri-ari entries." nil t)
	  (error "Header line for okuri-ari entries is missing!"))
      (or (search-forward "\n;; okuri-nasi entries." nil t)
	  (error "Header line for okuri-nasi entries is missing!")))
    (message "Saving Jisyo...")
    (get-buffer-create " *record*")
    (let* ((inhibit-quit t)
	   lines
	   (skk-jisyo (expand-file-name skk-jisyo))
	   (file-modes (file-modes skk-jisyo)))
      (save-window-excursion
	;; Originally, call-process was used to execute the Unix mv command.
	;; Masakazu Takahashi modified it as follows on 1991.10.1.
	(if skk-backup-jisyo (rename-file skk-jisyo skk-backup-jisyo t)
	  ;; modified at the suggestion of Kiyotaka Sakai, 1992.9.16
	  (delete-file skk-jisyo))
	(skk-create-file skk-jisyo)
	(set-file-modes skk-jisyo file-modes)
	(set-buffer (get-file-buffer skk-jisyo))
	(setq lines (count-lines (point-min) (point-max)))
	(skk-save-jisyo-subr)
	(message "Saving Jisyo...done.")
	(if (and skk-keep-record (> skk-count-kakutei 0))
	    (progn
	      (set-buffer " *record*")
	      (erase-buffer)
	      ;; modified by Yosiaki Iida, 1994.8.23.
	      (insert-file-contents skk-record-file)
	      (goto-char (point-min))
	      (insert
	       (format "%s  Ͽ: %3d  : %4d  Ψ: %3d%%  : %6d\n"
		       (current-time-string)
		       skk-count-touroku
		       skk-count-kakutei
		       (/ (* 100 (- skk-count-kakutei skk-count-touroku))
			  skk-count-kakutei)
		       lines))
	      (write-region (point-min) (point-max) skk-record-file nil 'nomsg)
	      (set-buffer-modified-p nil)))
	;; modified by Masakazu Takahashi, 1991.3.27
	(setq skk-count-touroku 0
	      skk-count-kakutei 0)
	;; reset skk-jisyo-buffer-modified
	(setq skk-jisyo-buffer-modified nil)))))

(defun skk-save-jisyo-subr ()
  (let ((go-on t))
    (goto-char (point-min))
    (while go-on
      (set-mark (point))
      (goto-char (+ 50000 (point)))
      (end-of-line)
      (write-region (mark) (point) skk-jisyo t 'nomsg)
      (if (eobp) (setq go-on nil)))))

;; input functions

;; modified by Wataru Matsui, 1991.8.19
;; modified by Masahiko Sato, 1990.3.19
;; modified by Masakazu Takahashi, 1989.8.10

(defun skk-newline (arg)
  (interactive "p")
  (let ((no-nl (and skk-egg-like-newline skk-henkan-on)))
    (if (skk-in-minibuffer-p)
	(progn
	  (skk-kakutei)
	  (if no-nl
	      nil
	    (setq skk-j-mode nil)
	    (exit-minibuffer)))
      (if (skk-kakutei) (setq arg (1- arg)))
      (if no-nl
	  nil
	(skk-emulate-original-map arg)))))

;; modified by Masakazu Takahashi, 1991.11.17
;; modified by Kazuo Hirokawa, 1991.11.18.

(defun skk-delete-backward-char (count)
  (interactive "P")
  (if skk-okurigana
      (progn
	(setq skk-okurigana nil)
	(if (and (char-after (+ skk-okurigana-start-point 0))
		 (= (char-after (+ skk-okurigana-start-point 0)) ?*))
	    (delete-region skk-okurigana-start-point
			   (1+ skk-okurigana-start-point)))))
  (if (and skk-henkan-on (= (point) skk-henkan-start-point))
      (progn
	(setq skk-henkan-count 0)
	(skk-kakutei))
    ;; modified by Tsugutomo Enami, 1991.10.2
    (if skk-henkan-active 
	;; modified by Shuji Ashizawa, 1993.8.17
	(let ((p (+ skk-henkan-end-point 0)))
	  (if (and (not skk-delete-implies-kakutei) (= p (point)))
	      (skk-previous-candidate)
           (delete-backward-char (prefix-numeric-value count) count)
           (if (< (point) p) (skk-kakutei))))
      (if (skk-in-minibuffer-p)
	  (delete-backward-char (prefix-numeric-value count))
	;; we should not emulate original map if skk-use-vip is t and
	;; vip-current-mode's value is insert-mode
	(if (and skk-use-vip (eq vip-current-mode 'insert-mode))
	    (delete-backward-char (prefix-numeric-value count)))
	(skk-emulate-original-map count)))))

;; input by EUC/JIS code or by menu

;; The function skk-input-by-code, which was used until version 4.20,
;; is now replaced by the following new function.  The code for this
;; function was contributed by nakamura@pluto.ai.kyutech.ac.jp

;; modified by Masahiko Sato, 1991.4.4
;; modified by Jun-ichi Nakamura, 1991.3.29

(defun skk-input-by-code-or-menu ()
  "This function lets the user input a JIS character either by its code or
by following the menu provided by the system."
  (interactive)
  (if (interactive-p)
      (insert (skk-input-by-code-or-menu))
    (let* ((str (read-string "JIS or EUC code (00nn or CR for Jump Menu): "))
	   (n1 (if (string= str "") 128
		 (+ (* 16 (j-jis-string-to-hex (substring str 0 1)))
		    (j-string-to-hex (substring str 1 2)))))
	   (n2 (if (string= str "") 128
		 (+ (* 16 (j-jis-string-to-hex (substring str 2 3)))
		    (j-string-to-hex (substring str 3 4)))))
	   ;; added by Takeshi Ohtani, 1994.6.14.
	   (enable-recursive-mini-buffer t))
      (if (> n1 160) (skk-char-to-string n1 n2)
	(skk-input-by-code-or-menu-0 n1 n2)))))

(defun j-string-to-hex (str)
  (let ((num (string-to-char str)))
  (cond ((> num 96) (- num 87)) ;; a-f
	((> num 64) (- num 55)) ;; A-F
	((> num 47) (- num 48)) ;; 0-9
	(t (error "")))))

(defun j-jis-string-to-hex (str)
  (let ((num (string-to-char str)))
  (cond ((> num 96) (- num 87)) ;; a-f
	((> num 64) (- num 55)) ;; A-F
	((> num 47) (- num 40)) ;; 0-9
	(t (error "")))))

(defun skk-char-to-string (n1 n2)
  (if skk-mule
      (char-to-string (make-character lc-jp n1 n2))
    (concat (char-to-string n1) (char-to-string n2))))

(defun skk-next-n2-code (n)
  (if (<= (setq n (1+ n)) skk-code-n2-max) n skk-code-n2-min))

(defun skk-previous-n2-code (n)
  (if (<= skk-code-n2-min (setq n (1- n))) n skk-code-n2-max))

(defun skk-next-n1-code (n)
  (if (<= (setq n (1+ n)) skk-code-n1-max) n skk-code-n1-min))

(defun skk-previous-n1-code (n)
  (if (<= skk-code-n1-min (setq n (1- n))) n skk-code-n1-max))

(defun skk-input-by-code-or-menu-0 (n1 n2)
  (if (= n1 skk-code-null)
      (skk-input-by-code-or-menu-jump n2)
    (skk-input-by-code-or-menu-1 n1 n2)))

(defun skk-input-by-code-or-menu-jump (n)
  (let ((kanji-char nil))
    (if (< n skk-code-n1-min) (setq n skk-input-by-code-or-menu-jump-default))
    (while (not kanji-char)
      (let* ((n-org n)
	     (chars
	      (list
	       (list (skk-char-to-string n skk-code-n1-min) n skk-code-n1-min)
	       (list (skk-char-to-string n 177) n 177)
	       (list (skk-char-to-string n 193) n 193)
	       (list (skk-char-to-string n 209) n 209)
	       (list (skk-char-to-string n 225) n 225)
	       (list (skk-char-to-string n 241) n 241)
	       (progn
		 (setq n (skk-next-n1-code n))
		 (list (skk-char-to-string n skk-code-n1-min) n skk-code-n1-min))
	       (list (skk-char-to-string n 177) n 177)
	       (list (skk-char-to-string n 193) n 193)
	       (list (skk-char-to-string n 209) n 209)
	       (list (skk-char-to-string n 225) n 225)
	       (list (skk-char-to-string n 241) n 241))))
	(save-excursion
	  (let ((i 0) (str ""))
	    (while (< i 12)
	      (setq str
		    (concat
		     str
		     (char-to-string (upcase
				      (nth i skk-input-by-code-menu-keys1)))
		     (car (nth i chars))
		     "  "))
	      (setq i (1+ i)))
	    (message str))
	  ;; modified by Kiyotaka Sakai, 1994.11.8.
	  (let* ((char (skk-read-char))
		 ;; modified by Kiyotaka Sakai, 1994.7.5.
		 (rest (memq char skk-input-by-code-menu-keys1))
		 (ch (if rest
			 (nth
			  (- (length skk-input-by-code-menu-keys1) (length rest))
			  chars)
		       nil)))
	    (setq kanji-char
		  (cond
		   (ch ch)
		   ((= char skk-previous-candidate-char)
		    (if (< (setq n (- n-org 2)) skk-code-n1-min)
			(setq n skk-code-n1-max))
		    nil)
		   ((= char 32)  ;;; space
		      (setq n (skk-next-n1-code n))
		      nil)
		   ((= char 63)  ;;; ?
		    (message
		     "%s  EUC: %2x%2x (%3d, %3d), JIS: %2x%2x (%3d, %3d)  [Hit any key to continue.]"
		     (car (car chars))
		     n-org skk-code-n1-min n-org skk-code-n1-min
		     (- n-org 128) (- skk-code-n1-min 128)
		     (- n-org 128) (- skk-code-n1-min 128))
		    ;; modified by Kiyotaka Sakai, 1994.11.8.
		    (skk-read-char)
		    (setq n n-org)
		    nil)
		   ((= char ?\C-g) (signal 'quit nil))
		   (t
		    (message
		     (format "`%c' is not valid here!" char))
		    (sit-for 1)
		    (message "")
		    (setq n n-org)
		    nil)))))))
    (setq skk-input-by-code-or-menu-jump-default (car (cdr kanji-char)))
    (skk-input-by-code-or-menu-1
     (car (cdr kanji-char)) (car (cdr (cdr kanji-char))))))

(defun skk-input-by-code-or-menu-1 (n1 n2)
  (let ((kanji-char nil))
    (while (not kanji-char)
      (let* ((n1-org n1) (n2-org n2) (i 0)
	     (chars (list (skk-char-to-string n1 n2))))
	(while (< i 16)
	  ;; modified by Kiyotaka Sakai, 19947.5.
	  (nconc chars (list
			(progn (setq n2 (skk-next-n2-code n2))
			       (if (= n2 skk-code-n2-min)
				   (setq n1 (skk-next-n1-code n1)))
			       (skk-char-to-string n1 n2))))
	  (setq i (1+ i)))
	(save-excursion
	  (let ((i 0) (str ""))
	    (while (< i 16)
	      (setq str
		    (concat
		     str
		     (char-to-string (upcase
				      (nth i skk-input-by-code-menu-keys2)))
		     (nth i chars)
		     " "))
	      (setq i (1+ i)))
	    (message str))
	  ;; modified by Kiyotaka Sakai, 1994.11.8.
	  (let* ((char (skk-read-char))
		 ;; modified by Kiyotaka Sakai, 1994.7.5.
		 (rest (memq char skk-input-by-code-menu-keys2))
		 (ch (if rest
			 (nth
			  (- (length skk-input-by-code-menu-keys2) (length rest))
			  chars)
		       nil)))
	    (setq kanji-char
		  (cond
		   (ch ch)
		   ((= char skk-previous-candidate-char)
		    (if (< (setq n2 (- n2 31)) skk-code-n2-min)
			(progn (setq n2 (+ n2 94)
				     n1 (skk-previous-n1-code n1))))
		    nil)
		   ((= char 32)  ;;; space
		    (if (= (setq n2 (skk-next-n2-code n2))
			   skk-code-n2-min)
			(setq n1 (skk-next-n1-code n1)))
		    nil)
		   ((= char 63)  ;;; ?
		    (message
		      "%s  EUC: %2x%2x (%3d, %3d), JIS: %2x%2x (%3d, %3d)  [Hit any key to continue.]"
		      (car chars) n1-org n2-org n1-org n2-org
		      (- n1-org 128) (- n2-org 128)
		      (- n1-org 128) (- n2-org 128))
		    ;; modified by Kiyotaka Sakai, 1994.11.8.
		    (skk-read-char)
		    (setq n1 n1-org n2 n2-org)
		    nil)
		   ((= char 62)  ;;; >
		    (if (= (setq n2 (skk-next-n2-code n2-org))
			   skk-code-n2-min)
			(setq n1 (skk-next-n1-code n1-org))
		      (setq n1 n1-org))
		    nil)
		   ((= char 60) ;;; < 
		    (if (= (setq n2 (skk-previous-n2-code n2-org))
			   skk-code-n2-max)
			(setq n1 (skk-previous-n1-code n1-org))
		      (setq n1 n1-org))
		    nil)
		   ((= char ?\C-g) (signal 'quit nil))
		   (t
		    (message "`%c' is not valid here!" char)
		    (sit-for 1)
		    (message "")
		    (setq n1 n1-org n2 n2-org)
		    nil)))))))
    kanji-char))

(defun skk-display-code-for-char-at-point ()
  "Displays the code for the charater at the current point."
  (interactive)
  (if (eobp) (error "Cursor is at the end of the buffer."))
  (let* ((str
	  ;; modified by Kazuo Hirokawa, 1992.2.26.
	  (buffer-substring
	   (point)
	   (save-excursion (forward-char 1) (point))))
	 (char-list (mapcar '+ str)))
    (if (= (length char-list) 1)
	;; ascii character
	(let ((char1 (car char-list)))
	  (message "`%c'  %2x (%3d)" char1 char1 char1))
      (if skk-mule
	  (if (and (= (length char-list) 3)
		   (= (car char-list) lc-jp))
	      (let* ((char1 (car (cdr char-list)))
		     (char1-j (- char1 128))
		     (char2 (car (cdr (cdr char-list))))
		     (char2-j (- char2 128)))
		(message
		 "%s  EUC: %2x%2x (%3d, %3d), JIS: %2x%2x (%3d, %3d)"
		 str char1 char2 char1 char2 char1-j char2-j char1-j char2-j))
	    (error "I don't understand this character."))
      (let* ((char1 (car char-list))
	     (char1-j (- char1 128))
	     (char2 (car (cdr char-list)))
	     (char2-j (- char2 128)))
	(message
	 "%s  EUC: %2x%2x (%3d, %3d), JIS: %2x%2x (%3d, %3d)"
	 str char1 char2 char1 char2 char1-j char2-j char1-j char2-j))))))

;; henkan routines

(defun skk-toggle-kana (arg)
  (interactive "P")
  (if (and skk-henkan-on (not skk-henkan-active))
      (skk-katakana-henkan arg)
    (skk-kakutei)
    (setq skk-katakana (not skk-katakana))
    (skk-change-mode-line (if skk-katakana skk-katakana-mode-string
			  skk-hirakana-mode-string))))

;(defun skk-set-henkan-point (&optional arg)

;; The following two functions, skk-katakana-region and skk-katakana-henkan,
;; were contributed by Wataru Matsui on 1991.8.27.

;; skk-katakana-region: modified by Wataru Matsui, 199l.11.19.
;;                    modified by Wataru Matsui, 1992. 1.21.
;;                    modified by Tsugutomo Enami, 1992.9.18.
;;    Arguments can be markers as well as numbers.
;;    Cf. katakana-region in wnn-egg.el, arguments to which 
;;    should not be markers.
;;    If vcontract is non-nil, "" is converted to "".
;;    The idea for this function comes from katakana-region in wnn-egg.el.

(defun skk-katakana-region (start end &optional vcontract)
  "Convert hiragana\'s in the region between START and END to katakana\'s.
Arguments start and end can be markers as well as numbers.
If vcontract is non-nil, \"\" is converted to \"\"."
  (interactive "r\nP")
  (save-excursion
    (save-restriction
      (narrow-to-region start end)
      (goto-char (point-min))
      (let (ch2 (diff (if skk-mule (- ? ?))))
	(while (re-search-forward  "[-]" nil t)
	  (if skk-mule
	      (progn
		(setq ch2 (+ (preceding-char) diff))
		(forward-char -1)
		(insert ch2)
		(delete-char 1))
	    (setq ch2 (preceding-char))
	    (forward-char -2)
	    (insert ?\245 ch2)
	    (delete-char 2))))
      (if vcontract
	  (progn
	    (goto-char (point-min))
	    (while (re-search-forward  "" nil t)
	      (if skk-mule
		  (progn
		    (forward-char -2)
		    (insert "")
		    (delete-char 2))
		(forward-char -4)
		(insert "")
		(delete-char 4))))))))

;; skk-hiragana-region: contributed by Wataru Matsui, 1991.11.19.
;;                       modified by Wataru Matsui, 1992. 1.21.
;;                       modified by Tsugutomo Enami, 1992.9.18.
;;    Arguments can be markers as well as numbers.
;;    Cf. hiragana-region in wnn-egg.el, arguments to which 
;;    should not be markers.
;;    "" and "" are not regarded as katakana's, since
;;    they don't have corresponding hiragana's.  If optional
;;    argument vexpand is non-nil, "" is converted to "".
;;    The idea for this function comes from hiragana-region in wnn-egg.el.

(defun skk-hiragana-region (start end &optional vexpand)
  "Convert katakana\'s in the region between START and END to hiragana\'s.
Arguments start and end can be markers as well as numbers.
If vexpand is non-nil, \"\" is converted to \"\".
\"\" and \"\" are left unchanged."
  (interactive "r\nP")
  (save-excursion
    (save-restriction
      (narrow-to-region start end)
      (goto-char (point-min))
      (let (ch2 (diff (if skk-mule (- ? ?))))
	(while (re-search-forward  "[-]" nil t)
	  (if skk-mule
	      (progn
		(setq ch2 (- (preceding-char) diff))
		(forward-char -1)
		(insert ch2)
		(delete-char 1))
	    (setq ch2 (preceding-char))
	    (forward-char -2)
	    (insert ?\244 ch2)
	    (delete-char 2))))
      (if vexpand
	  (progn
	    (goto-char (point-min))
	    (while (re-search-forward  "" nil t)
	      (if skk-mule
		  (progn
		    (forward-char -1)
		    (insert "")
		    (delete-char 1))
		(forward-char -2)
		(insert "")
		(delete-char 2))))))))

(defun skk-zenkaku-region (start end)
  "Convert ascii characters in the region between START and END to the
corresponding zenkaku characters."
  (interactive "r")
  (let ((diff (if skk-mule (- ? ?A))))
    (save-excursion
      (save-restriction
	(narrow-to-region start end)
	(goto-char (point-min))
	(while (re-search-forward "[ -~]" nil t)
	  (let ((ch (preceding-char)))
	    (if (and (<= ?  ch) (<= ch ?~))
		(progn
		  (forward-char -1)
		  (let ((zen (cdr (assq ch skk-zenkaku-alist))))
		    (if zen (insert zen)
		      (if skk-mule
			  (insert (+ ch diff))
			(insert ?\243 (+ ?\200 ch)))))
		  (delete-char 1)))))))))

;; modified by Kazuo Hirokawa, 1991.11.21.

(defun skk-katakana-henkan (arg)
  "Convert hiragana\'s between henkan start point and
henkan end point into katakana\'s.  Valid only in  mode."
  (interactive "P")
  (if skk-henkan-on
      (if (or skk-henkan-active skk-katakana)
	  nil
        (setq skk-j-mode t)
	(or (string= skk-prefix "") (error ""))
	(if (< (point) skk-henkan-start-point)
	    (error "Henkan end point must be after henkan start point."))
	(save-excursion
	  (beginning-of-line)
	  (if (> (point) skk-henkan-start-point)
	      (error "Henkan key may not contain a new line character.")))
	(move-marker skk-henkan-end-point (point))
	(skk-katakana-region skk-henkan-start-point skk-henkan-end-point t)
	(or arg (skk-kakutei))
	)
    (skk-emulate-original-map arg)
    ))

;; contributed by Kazuo Hirokawa, 1991.11.21.

(defun skk-hiragana-henkan (arg)
"Convert katakana\'s between henkan start point and
henkan end point into hiragana\'s.  Valid only in  mode."
  (interactive "P")
  (if skk-henkan-on
      (if (or skk-henkan-active (not skk-katakana))
	  nil
	(setq skk-j-mode t)
	(or (string= skk-prefix "") (error ""))
	(if (< (point) skk-henkan-start-point)
	    (error "Henkan end point must be after henkan start point."))
	(save-excursion
	  (beginning-of-line)
	  (if (> (point) skk-henkan-start-point)
	      (error "Henkan key may not contain a new line character.")))
	(move-marker skk-henkan-end-point (point))
	(skk-hiragana-region skk-henkan-start-point skk-henkan-end-point t)
	(or arg (skk-kakutei))
	)
    (skk-emulate-original-map arg)
    ))

;; contributed by Kazuo Hirokawa, 1991.11.21.

(defun skk-zenkaku-henkan (arg)
  "Convert hankaku\'s between henkan start point and
henkan end point into zenkaku\'s.  Valid only in  mode."
  (interactive "P")
  (if skk-henkan-on
      (if skk-henkan-active
	  nil
        (setq skk-j-mode t)
	(or (string= skk-prefix "") (error ""))
	(if (< (point) skk-henkan-start-point)
	    (error "Henkan end point must be after henkan start point."))
	(save-excursion
	  (beginning-of-line)
	  (if (> (point) skk-henkan-start-point)
	      (error "Henkan key may not contain a new line character.")))
	(move-marker skk-henkan-end-point (point))
	(skk-zenkaku-region skk-henkan-start-point skk-henkan-end-point)
	(or arg (skk-kakutei))
	)
    (skk-emulate-original-map arg)
    ))

; moved to skk-roma.el
;(defun skk-start-henkan (arg)

;(defun skk-set-henkan-point-subr ()

(defun skk-change-marker ()
  (save-excursion
    (goto-char (- skk-henkan-start-point skk-kanji-len))
    (if (looking-at "")
	(progn
	  (insert "")
	  (delete-char 1))
      (skk-kakutei)
      (error "It seems that you have deleted ."))))

(defun skk-change-marker-to-white ()
  (save-excursion
    (goto-char (- skk-henkan-start-point skk-kanji-len))
    (if (looking-at "")
	(progn
	  (insert "")
	  (delete-char 1))
      (goto-char skk-henkan-start-point)
      (insert "")
      (move-marker skk-henkan-start-point (point))
      (message "It seems that you have deleted ."))))

;; functions for handling numeric arguments in henkan key.

(defun skk-compute-numeric-henkan-key ()
  "return the modified version of skk-henkan-key where any consecutive
substring consisting of numeric chars like \"12\" or \"\" is
replaced by a #."
  (let (p (list nil) (val nil) (key skk-henkan-key))
    (if skk-use-numeric-conversion
	(progn
	  (save-excursion
	    (set-buffer (get-buffer-create " *skk-work*"))
	    (erase-buffer)
	    (insert key)
	    (goto-char (point-min))
	    (while (re-search-forward "\\([0-9]\\|[-]\\)" nil t)
	      (let (num)
		(goto-char (match-beginning 1))
		(setq p (point))
		(while (looking-at "\\([0-9]\\|[-]\\)")
		  (if (looking-at "[-]")
		      (progn
			;; modified by Kazuo Hirokawa, 1993.7.7
      			(if skk-mule
			    (insert
			     (- (char-component (following-char) 2) 128))
			  (insert (- (char-after (1+ (point))) 128)))
			(delete-char 1))
		    (forward-char 1)))
		(setq num (buffer-substring p (point)))
		(delete-region p (point))
		(insert "#")
                ;; modified by Mikio Nakajima, 1995.4.15
                (setq list (nconc list (list num)))))
	    (setq val (buffer-string)))
	  (setq skk-num-list list)
	  val)
      key)))

(defun skk-num-exp (num type)
  "convert the integer string NUM into a string according to TYPE."
  (let ((fun (cdr (assq type skk-num-type-list))))
    (if fun (apply fun (list num))
      num)))

(defun skk-zenkaku-num-str (num)
  "convert NUM to the string representing it in zenkaku numerals."
  (if (> (length num) 0)
      ;; modified by Masahiro Doteguchi, 1993.6.25.
      (concat (skk-zenkaku-num (aref num 0))
	      (skk-zenkaku-num-str (substring num 1)))
    ""))

(defun skk-zenkaku-num (num)
  (cdr (assq num
	     '((?0 . "") (?1 . "") (?2 . "") (?3 . "")
	       (?4 . "") (?5 . "") (?6 . "") (?7 . "")
	       (?8 . "") (?9 . "")))))

(defun skk-kanji-num-str (num)
  "convert NUM to the string representing it in zenkaku kanji numerals."
  (if (> (length num) 0)
      (concat (skk-kanji-num (aref num 0))
	      (skk-kanji-num-str (substring num 1)))
    ""))

(defun skk-kanji-num (num)
  (cdr (assq num
	     '((?0 . "") (?1 . "") (?2 . "") (?3 . "")
	       (?4 . "") (?5 . "") (?6 . "ϻ") (?7 . "")
	       (?8 . "Ȭ") (?9 . "")))))

(defun skk-kanji-num-str2 (num)
  "convert NUM to the string representing it in kanji.  e.g, 1021 will be
converted to \"󽽰\""
  (let ((str (skk-kanji-num-str2-subr num)))
    (if (string= "" str) "" str)))

(defun skk-kanji-num-str2-subr (num &optional silent0)
  "If the optional argument SILENT0 is t, the initial 0 of NUM string
will be supressed."
  (let* ((len (length num))
	 (l (substring num 0 1))
	 (r (substring num 1))
	 (c (string-to-char l)))
    (if (string= "" r)
	(if (= c ?0) "" (skk-kanji-num c))
      (or (string= l "0") (setq silent0 nil))
      (concat
       (if (or (= c ?0) (and (string= l "1") (not (= (mod len 4) 1))))
	   ""
	 (skk-kanji-num c))
       (if (and (string= l "0") (or silent0 (not (= (mod len 4) 1))))
	   ""
	 (cond ((= (mod len 4) 2) "")
	       ((= (mod len 4) 3) "ɴ")
	       ((= (mod len 4) 0) "")
	       ((= len 5) (setq silent0 t) "")
	       ((= len 9) (setq silent0 t) "")
	       ((= len 13) (setq silent0 t) "")
	       ((= len 17) (setq silent0 t) "")
	       (t (error "Too big num!"))))
       (skk-kanji-num-str2-subr r silent0)))))

(defun skk-shogi-num-str (num)
  "convert NUM to the representation used in Shogi.  e.g., 34 will be
converted to \"\"."
  (concat
   (skk-zenkaku-num (string-to-char num))
   (skk-kanji-num (string-to-char (substring num 1 2)))))

(defun skk-compute-henkan-vectors ()
  (let ((cont t) (stage 1)
	(v1 (vector)) (v2 (vector)) (v3 (vector)) (v4 (vector)))
    (while (and cont (not (eolp)))
      (let ((item (buffer-substring
		   (point)
		   (progn
		     (search-forward "/")
		     (1- (point))))))
	;; modified by Kiyotaka Sakai, 1994.4.1.
	(cond ((not okuri-ari)
	       (if (and skk-process-okuri-early (= (aref item 0) ?\[))
		   (setq cont nil)
		 (setq v1 (vconcat v1 (list item)))))
	      ((and (= (aref item 0) ?\[) (<= stage 2))
	       (if (string= item
			    (concat "\[" okurigana))
		   (progn
		     (setq stage 3)
		     (setq v2 (vconcat v2 (vector item))))
		 (setq stage 2)
		 (setq v2 (vconcat v2 (vector item)))))
	      ((and (= (aref item 0) ?\]) (= stage 3))
	       (setq stage 4)
	       (setq v4 (vconcat v4 (vector item))))
	      ((= stage 1)
	       (setq v1 (vconcat v1 (vector item))))
	      ((= stage 2)
	       (setq v2 (vconcat v2 (vector item))))
	      ((= stage 3)
	       (setq v3 (vconcat v3 (vector item))))
	      ((= stage 4)
	       (setq v4 (vconcat v4 (vector item)))))))
    (list v1 v2 v3 v4)))

;; the following function was added by Kiyotaka Sakai, 1994.4.1.
;; modified by Motohiko Mouri, 1994.4.4.
;; modified by Tsugutomo Enami, 1994.4.4.

(defun j-quote-char (word)
  "If WORD contains characters that are normally not part of dictionary
entries, then convert it into a lisp code that will return the word when
it is evaluated."
  (if (and (string-match "[/\n\r\"]" word)
	   ;; we should not quote WORD if it is a symbolic expression
	   (let ((l (length word)))
	     (not
	      (and (> l 2)
		   (= (aref word 0) ?\()
		   (< (aref word 1) 128)
		   (= (aref word (1- l)) ?\))))))
      (concat "(concat \""
	      (mapconcat (function (lambda (c)
				     (cond ((eq c ?/) "\\057")
					   ((eq c ?\n) "\\n")
					   ((eq c ?\r) "\\r")
					   ((eq c ?\") "\\\"")
					   ((eq c ?\\) "\\\\")
					   (t (char-to-string c)))))
			 (append word nil) "")
	      "\")")
    word))

(defun skk-update-jisyo (file word &optional purge)
  "update jisyo buffer associated to FILE so that WORD will become the first
candidate next time.  If PURGE is t, the word is removed from the jisyo entry."
  ;; if (get-file-buffer file) is nil, we have nothing to do
  (if (get-file-buffer file)
      (let ((vector1 [])
	    (vector2 [])
	    (vector3 [])
	    (vector4 [])
	    (len (length skk-henkan-vector))
	    (count (1- skk-henkan-count))
	    okuri-ari
	    min
	    max
	    (okurigana skk-henkan-okurigana)
	    key
	    entry-point
	    (inhibit-quit t)
	    (new-entry t))
	;; we don't have to auto-process okuri if skk-num-list is non-nil
	;; or the first character of skk-henkan-key is an ascii character.
	(if (and skk-auto-okuri-process
		 (not skk-num-list)
		 (> (aref skk-henkan-key 0) 127)
		 (or (> skk-henkan-count len)
		     (and (< skk-okuri-index-min skk-henkan-count)
			  (<= skk-henkan-count skk-okuri-index-max))))
	    (j-remove-common))
	;; we must re-compute okuri-ari, since skk-henkan-key might have been
	;; changed by j-remove-common
	(setq okuri-ari ;; used in skk-compute-henkan-vectors
	      (let ((char (aref skk-henkan-key (1- (length skk-henkan-key)))))
		(and (> (aref skk-henkan-key 0) 127)
		     (<= ?a char)
		     (<= char ?z))))
	(setq key (concat (if okuri-ari skk-henkan-key skk-search-key) " /"))
	(save-excursion
	  (set-buffer (get-file-buffer file))
	  (setq min (if okuri-ari skk-okuri-ari-min skk-okuri-nasi-min))
	  (setq max (if okuri-ari skk-okuri-ari-max (point-max)))
	  ;; we have to backup one character so that we can find key correctly
	  ;; even if it is the first entry in the region bounded by min and max
	  (goto-char (1- min))
	  ;; delete old entry
	  (if (search-forward (concat "\n" key) max t)
	      (progn
		(let ((l (skk-compute-henkan-vectors)))
		  (setq vector1 (nth 0 l)
			vector2 (nth 1 l)
			vector3 (nth 2 l)
			vector4 (nth 3 l)))
		(setq new-entry nil)
		(delete-region
		 (progn (beginning-of-line) (point))
		 (progn (end-of-line) (forward-char 1) (point)))))
	  ;; insert new entry
	  (if okuri-ari
	      (if new-entry
		  (let (p)
		    (goto-char min)
		    (setq p (point))
		    ;; modified by Kazuo Hirokawa, 1991.6.10
		    (while (and (not (= (point) max))
				(string< key
					 (progn
					   (search-forward " /")
					   (buffer-substring p (point)))))
		      (forward-line 1)
		      (setq p (point)))))
	    (goto-char min))
	  (beginning-of-line)
	  (setq entry-point (point))
	  (insert key
		  (if purge
		      ""
		    (concat
		     (if (and (not new-entry)
			      skk-use-numeric-conversion
			      skk-num-list
			      (< count (length vector1)))
			 (setq word (aref vector1 count))
		       (j-quote-char word))
		     "/")))
	  (let ((index 0) (len (length vector1)))
	    (while (< index len)
	      (let ((w (aref vector1 index)))
		(or (string= word w) (insert (j-quote-char w) "/"))
		(setq index (1+ index)))))
	  (if (and okuri-ari (not skk-process-okuri-early))
	      (progn
		(let ((index 0) (len (length vector2)))
		  (while (< index len)
		    (insert (aref vector2 index) "/")
		    (setq index (1+ index))))
		(if (equal vector3 [])
		    (or purge (insert "\[" okurigana "/" word "/\]/"))
		  (let ((index 0) (len (length vector3)))
		    (or purge (insert word "/"))
		    (while (< index len)
		      (let ((w (aref vector3 index)))
			(or (string= word w)
			    (insert w "/"))
			(setq index (1+ index))))))
		(let ((index 0) (len (length vector4)))
		  (if (> len 0)
		      (let ((p (point)))
			(save-excursion
			  (search-backward "/" nil nil 2)
			  (if (looking-at  "/\\[")
			      (progn
				(delete-region (1+ (point)) p)
				(setq index 1))))))
		  (while (< index len)
		    (insert (aref vector4 index) "/")
		    (setq index (1+ index))))))
	  (if purge
	      (let ((uniq t) (index 0) (l2 (length vector2))
		    (l4 (length vector4)))
		(while (and uniq (< index l2))
		  (if (string= word (aref vector2 index))
		      (setq uniq nil)
		    (setq index (1+ index))))
		(setq index 0)
		(while (and uniq (< index l4))
		  (if (string= word (aref vector4 index))
		      (setq uniq nil)
		    (setq index (1+ index))))
		(if uniq
		    ;; the WORD is not in vector2 nor in vector4, so purge it
		    ;; also from vector1 (if any)
		    (save-excursion
		      (let ((q (point)))
			(goto-char entry-point)
			(search-forward " ")
			(if (search-forward (concat "/" word "/") q t)
			    (delete-region (1+ (match-beginning 0))
					   (match-end 0))))))))
	  (insert "\n")
	  (forward-line -1)
	  (search-forward " /")
	  (if (eolp)
	      ;; the key has no words for it so delete everything
	      (delete-region (save-excursion (beginning-of-line) (point))
			     (1+ (point))))
	  (if okuri-ari
	      ;; in this case, we need to reset skk-okuri-ari-max and
	      ;; skk-okuri-nasi-min
	      (progn
		(goto-char min)
		(search-forward "\n;; okuri-nasi")
		(beginning-of-line)
		(setq skk-okuri-ari-max (point))
		(forward-line 1)
		(setq skk-okuri-nasi-min (point))))
	  (setq skk-jisyo-buffer-modified
		(or skk-jisyo-buffer-modified
		    (buffer-modified-p)))
	  (set-buffer-modified-p nil)))))

(defun j-remove-common ()
  "remove trailing common kana ending parts both from midasi and word.
For instance, (äƤ äƤ) -> key := \"t /\",
okurigana := \"ä\", word := \"\""
  (let* ((midasi skk-henkan-key)
	 (midasi-len (length midasi))
	 (word-len (length word))
	 ;; the following two variables were introduced by
	 ;; GUNJI Takao, 1993.9.27
	 (kanji-len2 (* 2 skk-kanji-len))
	 char pos2)
    (if (and (>= midasi-len kanji-len2) (>= word-len kanji-len2))
	(progn
	  ;; check if both midasi and word end with the same ascii char.
	  (if (and (string= (substring midasi -1) (substring word -1))
		   (< (string-to-char (substring midasi -1)) 128))
	      ;; if so chop off the char from midasi and word
	      (setq midasi (substring midasi 0 -1)
		    midasi-len (1- midasi-len)
		    word (substring word 0 -1)
		    word-len (1- word-len)))
	  (let ((midasi-tail
		 (substring midasi (- midasi-len skk-kanji-len) midasi-len))
		(word-tail (substring word (- word-len skk-kanji-len) word-len)))
	    (if (and (string= midasi-tail word-tail)
		     (or
		      (and
		       (j-string<= "" midasi-tail)
		       (j-string<= midasi-tail ""))
		      (string= "" midasi-tail)
		      (string= "" midasi-tail)
		      (string= "" midasi-tail)
		      (string= "" midasi-tail)))
		(let ((pos (- word-len skk-kanji-len))
		      (cont t)
		      new-word new-skk-henkan-key)
		  (while (and cont (> pos 0))
		    (setq char (substring word (- pos skk-kanji-len) pos))
		    (if (and (j-string<= "" char) (j-string<= char ""))
			;; char is the right-most Kanji
			(setq cont nil)
		      (setq pos (- pos skk-kanji-len))))
		  (setq pos2 (- midasi-len (- word-len pos)))
		  ;; check if midasi and word has the same tail of length
		  ;; (- word-len pos)
		  (if (string= (substring midasi pos2 midasi-len)
			       (substring word pos word-len))
		      (let ((okuri-first
			     (substring word pos (+ pos skk-kanji-len))))
			(setq okurigana
			      (if (and (string= okuri-first "")
				       (<= (+ pos kanji-len2) word-len))
				  ;; in this case okuriga consits of two
				  ;; characters, e.g., ֻĤä
				  (substring word pos (+ pos kanji-len2))
				okuri-first))
			(setq new-word (substring word 0 pos))
			(setq new-skk-henkan-key
			      (concat
			       (substring midasi 0 pos2)
			       (if (string= okuri-first "")
				   "n"
				 (if (string= okuri-first "")
				     (aref skk-kana-rom-vector
					   (- (string-to-char
					       (substring
						okurigana
						(1- kanji-len2) kanji-len2))
					      161))
				   (aref skk-kana-rom-vector
					 (- (string-to-char
					     (substring
					      okurigana
					      (1- skk-kanji-len) skk-kanji-len))
					    161))))))
			(if (> skk-henkan-count len)
			    ;; ask if register as okuri-ari word.
			    (let (;; allow keyboard quit
				  (inhibit-quit nil))
			      (if (y-or-n-p
				   (format
				    "Shall I register this as okuri-ari entry: %s /%s/ ? "
				    new-skk-henkan-key new-word))
				  (setq word new-word
					skk-henkan-key new-skk-henkan-key))
			      (message ""))
			  (setq word new-word
				skk-henkan-key new-skk-henkan-key)))))))))))

(defun j-string<= (str1 str2)
  (or (string< str1 str2) (string= str1 str2)))

(defun skk-henkan ()
  "The main kana-to-kanji conversion routine."
  (let ((eobp (eobp)) ; modified by Mikio Nakajima, 1995.5.10
	 ;; we use mark to go back to the correct position after henkan
	 (mark (make-marker))
	 new-word-entered)
    (or eobp
	(forward-char 1)
	(move-marker mark (point)))
    (save-excursion
      (or skk-henkan-active
	  (skk-change-marker)
	  (setq skk-henkan-active t
		skk-current-search-prog-list skk-search-prog-list))
      (if (string= skk-henkan-key "")
	  (skk-kakutei)
	(let (new-word
	      (found nil) (kakutei nil) (quit nil)
	      (cont t) (l1 0) (l2 0))
	  (if (= skk-henkan-count 0)
	      (progn
                ;; modified by Mikio Nakajima, 1995.4.15
		(if (equal skk-henkan-vector [])
		    (progn
		      (if (eq last-command 'skk-undo-kakutei)
			  ;; in this case, we should not search kakutei jisyo.
			  (setq skk-current-search-prog-list (cdr skk-search-prog-list)))
		      (setq skk-okuri-ari
			    (let ((char
				   (aref skk-henkan-key
					 (1- (length skk-henkan-key)))))
			      (and (> (aref skk-henkan-key 0) 127)
				   (<= ?a char)
				   (<= char ?z)))
			    skk-henkan-vector (skk-search))))
		;; added by I. Minoura (1997.12.8)
		(run-hooks 'skk-henkan-sort-hook)
		;; modified by Mikio Nakajima, 1995.4.15
		;; modified by Mikio Nakajima, 1995.5.10
		(if (not (equal skk-henkan-vector []))
		    (setq found t
			  skk-henkan-count 1
			  new-word (aref skk-henkan-vector 0))))
	    (if (< skk-henkan-count (length skk-henkan-vector))
		(setq new-word (aref skk-henkan-vector skk-henkan-count)
		      found t)
	      ;; call skk-search repeateldly, until we find new candidates
	      ;; or until skk-current-search-prog-list becomes empty
	      (while (and skk-current-search-prog-list (= l1 l2))
		(setq l1 (length skk-henkan-vector))
		(setq skk-henkan-vector
		      (skk-vector-add skk-henkan-vector (skk-search)))
		(setq l2 (length skk-henkan-vector)))
	      (if (< skk-henkan-count (length skk-henkan-vector))
		  (setq new-word (aref skk-henkan-vector skk-henkan-count)
			found t)))
	    (if (< skk-henkan-count 4)
		(if found (setq skk-henkan-count (1+ skk-henkan-count)))
	      (if found
		  ;; show candidates in minibuffer
		  (skk-henkan-show-candidates))))
	  (or quit
	      (if found
		  (progn
		    (delete-region skk-henkan-start-point skk-henkan-end-point)
		    (goto-char skk-henkan-start-point)
		    (skk-insert-word new-word)
		    (move-marker skk-henkan-end-point (point))
		    (if kakutei
			(let ((skk-prefix skk-prefix))
			  ;; save and restore skk-prefix after skk-kakutei
			  (skk-kakutei new-word))))
		;; use recursive minibuffer
		(let ((save-start (copy-marker skk-henkan-start-point))
		      (save-end (copy-marker skk-henkan-end-point))
		      ;; added by IIDA Yosiaki, 1994.3.18.
		      (enable-recursive-minibuffers t) ; Added by IIDA
		      ;; inhibit isearch message while doing henkan
		      (skk-isearch-message nil))
		  (setq new-word-entered (j-henkan-in-minibuff))
		  (move-marker skk-henkan-start-point save-start)
		  (move-marker skk-henkan-end-point save-end)
		  (if new-word-entered
		      (progn
			(delete-region skk-henkan-start-point
				       skk-henkan-end-point)
			(goto-char skk-henkan-start-point)
			(skk-insert-word new-word)
			(move-marker skk-henkan-end-point (point))
			(if kakutei
			    (let ((skk-prefix skk-prefix))
			      ;; save and restore skk-prefix after
			      ;; skk-kakutei
			      (skk-kakutei new-word)))))))))))
    (if eobp
	(goto-char (point-max))
      (goto-char mark)
      (or (and overwrite-mode new-word-entered) (backward-char 1)))))

(defun skk-insert-word (word)
  "Insert WORD at point.  If SKK-USE-NUMERIC-CONVERSION is t, WORD will
be modified using skk-num-list, and the the modified word will be inserted."
  (if (and skk-use-numeric-conversion skk-num-list)
      (setq word (j-numeric-convert word)))
  (if (string-match "^(.*)$" word)
      (condition-case conditions
	  (insert (eval (car (read-from-string word))))
	(quit (insert word))
	(error (insert word)))
    (insert word)))

;; modified by Mikio Nakajima, 1995.4.11
(defun skk-search ()
  "search skk-henkan-key using the programs in the list skk-current-search-prog-list."
  (let ((v []))
    (while (and (equal v []) skk-current-search-prog-list)
      (setq v (eval (car skk-current-search-prog-list))
            skk-current-search-prog-list (cdr skk-current-search-prog-list) ))
    v ))

;; introduced at the suggestion of Katuya Tomioka, 92.4.20
(defun skk-search-jisyo-file (file limit &optional nomsg)
  "search henkan-key in skk format jisyo file FILE.  binary search is
performed until the search region becomes less than LIMIT, and then
switch to linear search.  if LIMIT is 0, only linear search is done.
if the jisyo file is not sorted, you should set LIMT to be 0.  optional
argument NOMSG, if t, supresses the message."
  (let (ari-min ari-max nasi-min)
    (if file
	(progn
	  (skk-get-file-buffer file nomsg)
	  (save-excursion
	    (set-buffer (get-file-buffer file))
	    (setq ari-min skk-okuri-ari-min
		  ari-max skk-okuri-ari-max
		  nasi-min skk-okuri-nasi-min))
	  (skk-search-sorted-buffer
	   (if skk-okuri-ari skk-henkan-key skk-search-key)
	   (get-file-buffer file)
	   limit
	   (if skk-okuri-ari ari-min nasi-min)
	   (if skk-okuri-ari ari-max nil)
	   (if skk-okuri-ari t nil)))
      [])))

(defun skk-get-file-buffer (file &optional nomsg)
  "Create a unique buffer for skk formated FILE and initialize some
local variables."
  (or (get-file-buffer file)
      (save-excursion
	(setq file (expand-file-name file))
	(set-buffer
	 (generate-new-buffer
	  (concat " *" (file-name-nondirectory file) "*")))
	(setq buffer-file-name file)
	;; suggested by Masakazu Takahashi, 1992.1.26.
	(setq case-fold-search nil)
	(buffer-flush-undo (current-buffer))
	(or nomsg
	    (message "Inserting contents of %s ..."
		     (file-name-nondirectory file)))
	(insert-file-contents file)
	(or nomsg
	    (message "Inserting contents of %s ...done"
		     (file-name-nondirectory file)))
	(set-buffer-modified-p nil)
	(if (= (point-min) (point-max))
	    ;; if the file is empty, we make it a minimal well
	    ;; formed skk jisyo
	    (insert ";; okuri-ari entries.\n"
		    ";; okuri-nasi entries.\n"))
	(goto-char (point-min))
	(if (search-forward ";; okuri-ari entries.\n" nil t)
	    (progn
	      (setq skk-okuri-ari-min (point))
	      ;; modified at the suggestion of MIYOSHI Tsutomu, 1992.9.30
	      (backward-char 1)
	      (if (search-forward "\n;; okuri-nasi entries." nil t)
		  (progn
		    (beginning-of-line)
		    (setq skk-okuri-ari-max (point))
		    (end-of-line)
		    (setq skk-okuri-nasi-min (1+ (point))))
		(error "%s is not well formed!" file)))
	  (error "%s is not well formed!" file))
	(current-buffer))))

(defun skk-search-kakutei-jisyo-file (file limit &optional nomsg)
  "search jisyo file, and return the first candidate as a string.  if no
candidates are found, return an empty vector."
  (let ((v (skk-search-jisyo-file file limit nomsg)))
    (if (equal v [])
	[]
      (aref v 0))))

(defun skk-search-sorted-buffer (key buffer limit &optional min max reverse)
  "search KEY in BUFFER which is assumed to be sorted. try binary
search first until the size of the search region becomes less than LIMIT.
If LIMIT is 0, only linear seach is done.  optional arguments MIN and MAX
bounds the search region.  if the optional argument REVERSE is t,
comparison will be done by reversed order."
  (let ((okurigana skk-henkan-okurigana) ;; used in skk-compute-henkan-vectors
	(okuri-ari skk-okuri-ari) ;; used in skk-compute-henkan-vectors
	;; when merge-all-entry is nil, only the entry with strcitly
	;; matched okurigana is returned.
	(merge-all-entry (or (not skk-okuri-ari) (not skk-henkan-okuri-strictly)))
	size p l)
    (save-excursion
      (set-buffer buffer)
      (setq min (or min (point-min))
	    max (or max (point-max))
	    size (- max min))
      ;; modified by Mikio Nakajima, 1995.4.19
      (if (> limit 0)
          (while (> size limit)
	    (goto-char (+ min (/ size 2)))
	    (beginning-of-line)
	    (setq p (point))
	    (if (if reverse
		    (string<
		     (buffer-substring
                      p                 ; modified by Mikio Nakajima, 1995.5.10
		      (progn (search-forward " ") (1- (point))))
		     key)
		  (string<
		   key
		   (buffer-substring
                    p                   ; modified by Mikio Nakajima, 1995.5.10
		    (progn (search-forward " ") (1- (point))))))
		(setq max p)
	      (setq min p))
            (setq size (- max min)) ))
      (goto-char min)
      ;; backup one character so that we can find the key correctly even
      ;; if the key is at the beginning of the search region.
      (or (bobp) (backward-char 1))
      ;; modified by Mikio Nakajima, 1995.5.10
      (let ((w (concat "\n" key " /"))
	    (kanji-flag nil)
            (mc-flag nil)               ; added by Mikio Nakajima, 1995.4.18
	    (case-fold-search nil))
	;; kanji-flag must be set nil for efficiency.
        ;; modified by Mikio Nakajima, 1995.5.10
        (setq l (if (search-forward w max t)
		    (skk-compute-henkan-vectors)
                  '([] [] [] []) )))
      ;; added by Tsugutomo Enami, 1994.5.30.
      (if merge-all-entry
	  (skk-vector-add (nth 2 l) (nth 0 l))
	(nth 2 l) ))))

(defun skk-okuri-search ()
  (let (v)
    (if (and
	 ;; modified by Takeshi Ohtani, 1995.4.25
	 (not skk-abbrev)
	 skk-auto-okuri-process
	 (not skk-process-okuri-early)
	 (not skk-okuri-ari)
	 ;; we don't do auto-okuri-process if henkan key
	 ;; contains numerals
	 (not skk-num-list)
	 ;; suggested by Kazuo Hirokawa, 1991.10.30.
	 (> (length skk-henkan-key) 1))
	(progn
	  (setq skk-okuri-index-min (length skk-henkan-vector))
	  (setq v (skk-okuri-search-subr))
	  (setq skk-okuri-index-max (+ skk-okuri-index-min (length v)))
	  v)
      [])))

(defun skk-okuri-search-subr ()
  (let* ((henkan-key skk-henkan-key)
	 ;; modified by GUNJI Takao, 1993.11.1
	 (key (substring henkan-key 0 (if skk-mule 3 2)))
	 (len (length henkan-key))
	 (key1 (concat "\n" key))
	 key2 len2
	 key3 len3 okuri3
	 (kanji-flag nil)
         (mc-flag nil) ; added by Mikio Nakajima, 1995.4.18
	 (inhibit-quit t)
	 p q r s
	 (v (vector))
	 )
    (save-excursion
      (set-buffer (get-file-buffer skk-jisyo))
      (goto-char (1- skk-okuri-ari-min))
      (while (search-forward key1 skk-okuri-ari-max t)
	(setq p (point))
	(search-forward " ")
	(setq key2 (concat key (buffer-substring p (- (point) 2)))
	      len2 (length key2))
	(if (and
	     (<= len2 len)
             ;; modified by Mikio Nakajima,  1995.4.18
	     (string= key2 (substring henkan-key 0 len2)) )
	    (let ((cont t))
	      (save-excursion
		(end-of-line)
		(setq q (point)))
	      (while (and cont
			  (search-forward "/[" q t))
		(setq r (point))
		(search-forward "/")
		(setq okuri3 (buffer-substring r (1- (point)))
		      key3 (concat key2 okuri3)
		      len3 (length key3))
		(if (and
		     (<= len3 len)
                     ;; modified by Mikio Nakajima, 1995.4.18
		     (string= key3 (substring henkan-key 0 len3)) )
		    ;; finally found a candidate!
		    (let ((okuri
			   (concat okuri3
				   (substring henkan-key len3 len))))
		      (while (not (looking-at "\]"))
			(setq s (point))
			(search-forward "/" skk-okuri-ari-max t)
			(setq v (vconcat v
					 (vector
					  (concat
					   (buffer-substring s (1- (point)))
					   okuri)))))
		      ;; it is not necessary to seach for "\[" on this line
		      ;; any more
		      (setq cont nil)))))))
      v)))

(defun j-numeric-convert (word)
  "If skk-num-list is non-nil, convert WORD by substituting appropriate strings
for the occurrences of # in the WORD."
  (let ((list skk-num-list) num)
    (if list
	(save-excursion
	  (set-buffer (get-buffer-create " *skk-work*"))
	  (erase-buffer)
	  (insert word)
	  (goto-char (point-min))
	  (while (and list (search-forward "#" nil t))
	    (setq num (car list))
	    (let ((char (following-char)))
	      (delete-region (1- (point)) (1+ (point)))
	      (insert (skk-num-exp num char))
	      (setq list (cdr list))))
	  (buffer-string))
      word)))

(defun skk-henkan-show-candidates (&optional h-start)
  "Show candidates in the minibuffer."
  (let ((cont t) (count 1) (l (length skk-henkan-vector)))
    (or h-start (setq h-start 4))
    (setq found t)
    (delete-region skk-henkan-start-point skk-henkan-end-point)
    (let ((h-count skk-henkan-count) (unread nil)
	  ;; Modified by Masakazu Takahashi, 1991.11.18
	  ;; Added following to enable interruption while executing
	  ;; skk-isearch.
	  (inhibit-quit nil))
      (save-excursion
	(while (and skk-current-search-prog-list (< (- l h-count) 7))
	  (setq skk-henkan-vector (skk-vector-add skk-henkan-vector (skk-search))
		l (length skk-henkan-vector)))
	(if (= h-count l)
	    (setq cont nil found nil))
	(while cont
	  (while (and skk-current-search-prog-list (< (- l h-count) 7))
	    (setq skk-henkan-vector (skk-vector-add skk-henkan-vector (skk-search))
		  l (length skk-henkan-vector)))
	  (if (= h-count l)
	      (setq cont nil)
	    (let ((i 1) str)
	      (setq str
		    (concat
		     (char-to-string (upcase
				      (nth 0 skk-henkan-show-candidates-keys)))
		     ":"
		     (j-aref skk-henkan-vector h-count)))
	      (while (and (< (+ h-count i) l) (< i 7))
		(setq str
		      (concat
		       str
		       "  "
		       (char-to-string (upcase
					(nth i skk-henkan-show-candidates-keys)))
		       ":"
		       (j-aref skk-henkan-vector (+ h-count i))))
		(setq i (1+ i)))
	      (setq str
		    (concat
		     str
		     (format "  [Ĥ %d%s]"
			     (1+ (- l (+ h-count
					 (setq count
					       (min 8 (1+ (- l h-count)))))))
			     (make-string (length skk-current-search-prog-list) ?+))))
	      (princ str))
	    (setq h-count (+ h-count (1- count)))
	    (condition-case conditions
		;; modified by Kiyotaka Sakai, 1994.11.8.
		(let* ((char (skk-read-char))
		       (nth -1)
		       (char-val-pair
			(assq char
			      (mapcar
			       (function
				(lambda (x) (setq nth (1+ nth)) (cons x nth)))
				skk-henkan-show-candidates-keys))))
		  (cond (char-val-pair
			 (let ((c (cdr char-val-pair)))
			   (if (> (+ c 2) count)
			       (progn
				 (message "`%c' is not valid here!" char)
				 (sit-for 1)
				 (message "")
				 (setq h-count
				       (- h-count (1- count))))
			     ;; modified by Kazuo Hirokawa, 1992.5.15
			     (setq h-count
				   (+ (- h-count count) c 2))
			     (setq new-word
				   (aref skk-henkan-vector (1- h-count)))
			     (setq kakutei t cont nil))))
			((= char skk-previous-candidate-char)
			 (let* ((a (/ (- h-count (1+ h-start)) 7))
				(b (- h-count (+ h-start (* 7 a)))))
			   (if (= a 0)
			       (setq h-count (- h-count (1- b))
				     cont nil unread t)
			     (setq h-count (- (- h-count b) 7)))))
			((= char 32)
			 (if (and (= h-count l) (null skk-current-search-prog-list))
			     ;; no more candidates
			     (setq cont nil found nil)))
			((= char ?\C-g) (signal 'quit nil))
			(t
			 (message "`%c' is not valid here!" char)
			 (sit-for 1)
			 (message "")
			 (setq h-count (- h-count (1- count))))))
	      (quit
	       (setq h-count 1 cont nil unread t))))))
      (if unread (setq unread-command-char skk-previous-candidate-char quit t))
      (setq skk-henkan-count h-count))))

(defun j-henkan-in-minibuff ()
  (setq new-word
	(let (r-word (h-count skk-henkan-count))
	  (condition-case conditions
	      (setq r-word
		    (read-from-minibuffer
		     (concat
		      (if skk-num-list
			  skk-search-key
			(or skk-henkan-key2 skk-henkan-key))
		      " ")
		     nil
		     (progn
		       (skk-setup-minibuff-map)
		       skk-minibuff-map)))
	    (quit
	     (setq r-word "")))
	  (setq skk-henkan-count h-count)
	  r-word))
  (if (string= new-word "")
      (cond ((> skk-henkan-count 4)
	     (let* ((a (/ (- skk-henkan-count 5) 7))
		    (b (- skk-henkan-count (+ 4 (* 7 a)))))
	       (setq skk-henkan-count (- skk-henkan-count b))
	       (skk-henkan)))
	    ((= skk-henkan-count 0)
	     (setq skk-henkan-active nil
		   skk-henkan-key2 nil
		   )
	     (let ((skk-henkan-start-point save-start))
	       (skk-change-marker-to-white)))
	    (t nil))
    (setq kakutei t)
    (setq skk-count-touroku (1+ skk-count-touroku))
    (setq skk-henkan-count (1+ skk-henkan-count)))
  (not (string= new-word "")))

(defun j-aref (vector index)
  "Get the element of VECTOR at index INDEX.  If SKK-USE-NUMERIC-CONVERSION
is t, modify the result appropriately using skk-num-list."
  (let ((word (aref vector index)))
    (if (and skk-use-numeric-conversion skk-num-list)
	(j-numeric-convert word)
      word)))

;(defun skk-next-candidate ()
;  "Show next henkan candidate."
;  (if skk-henkan-active
;      (progn
;	;;(insert " ")
;	(skk-henkan)
;	;;(delete-backward-char 1)
;	)))

(defun skk-previous-candidate (&optional arg)
  "Show previous henkan candidate."
  (interactive "p")
  (if (and skk-henkan-active (not (string= skk-henkan-key "")))
      (progn
	(insert " ")
	(let ((word (concat skk-henkan-key " ")) new-word
	      (found nil) p q)
	  (save-excursion
	    (cond ((= skk-henkan-count 1)
		   (setq skk-henkan-active nil
			 skk-henkan-count 0
			 skk-okuri-index-min 0
			 skk-okuri-index-max 0
			 skk-henkan-vector []
			 skk-okurigana nil
			 skk-henkan-okurigana nil
			 skk-henkan-key2 nil
			 skk-num-list nil)
		   (setq q (point-marker))
		   (delete-region skk-henkan-start-point skk-henkan-end-point)
		   (goto-char skk-henkan-end-point)
		   (insert skk-henkan-key)
		   (if (> (length skk-prefix) 0)
		       (set-marker skk-kana-start-point (point)))
		   (setq p (point-marker))
		   (goto-char skk-henkan-start-point)
		   (if (> (following-char) 127)
		       (progn
			 ;; roman prefix for okurigana is removed
			 (while (and (< (point) p) (> (following-char) 127))
			   (forward-char 1))
			 (if (and (<= ?a (following-char))
				  (<= (following-char) ?z))
			     (delete-region (point) p)))
		     (goto-char p))
		   (skk-change-marker-to-white))
		  ((<= skk-henkan-count 7)
		   (setq word (aref skk-henkan-vector (- skk-henkan-count 2)))
		   (delete-region skk-henkan-start-point skk-henkan-end-point)
		   (goto-char skk-henkan-end-point)
		   (skk-insert-word word)
		   (move-marker skk-henkan-end-point (point))
		   (setq skk-henkan-count (1- skk-henkan-count)))
		  ((< 7 skk-henkan-count)
		   (setq skk-henkan-count (- skk-henkan-count 8))
		   (setq unread-command-char 32) ;; 32 is space char
		   )))
	  (if (and (> (point) 1) (= (char-after (1- (point))) 32))
	      (delete-backward-char 1))
	  (if (= skk-henkan-count 0)
	      (progn
		(if skk-auto-okuri-process (goto-char q) (goto-char p))
		(if skk-abbrev (use-local-map skk-abbrev-map))))))
    (if (eq last-command 'skk-kakutei-henkan)
	;; restore the state just before the last kakutei henkan.
	(progn
	  (delete-region skk-henkan-start-point (point))
	  (skk-set-henkan-point-subr)
	  (insert skk-kakutei-key)
	  (setq this-command 'skk-undo-kakutei))
      (if skk-use-nicola
	  (skk-emulate-original-map arg)
	(skk-kana-input)))))

(defun skk-keyboard-quit ()
  "If skk-henkan-active, abort showing henkan candidates and return to the
skk-henkan-on status; if skk-henkan-on, delete region between current point and
skk-henkan-start-point; otherwise same as keyboard-quit"
  (interactive)
  (if (string= skk-henkan-key "")
      (if (skk-in-minibuffer-p) (abort-recursive-edit) (keyboard-quit)))
  (if skk-henkan-active
      (if (and skk-delete-okuri-when-quit skk-okuri-ari)
	  (let ((p (point-marker)))
	    (setq skk-henkan-count 1)
	    (skk-previous-candidate)
	    (delete-region p (point)))
	(setq skk-henkan-count 1)
	(skk-previous-candidate))
    (if skk-henkan-on
	;; modified by Kiyotaka Sakai, 1994.7.5.
	(progn
	  (if (> (point) skk-henkan-start-point)
	      (delete-region (point) skk-henkan-start-point))
	  (skk-kakutei))
      (if (skk-in-minibuffer-p) (abort-recursive-edit) (keyboard-quit)))))

(defun skk-kakutei (&optional word)
  "This function does what it says. If WORD is given, it is used as the new
word for jisyo update."
  (interactive)
  (let ((inhibit-quit t))
    (if skk-mode
	(progn
	  (skk-change-mode-line (if skk-katakana skk-katakana-mode-string
				skk-hirakana-mode-string))
	  (use-local-map skk-map))
      ;; if skk-mode has not been called in this buffer, call it now.
      (skk-mode 1))
    (setq skk-j-mode t
	  skk-prefix "")
    (if skk-henkan-on
	(progn
	  (if (and skk-henkan-active (> skk-henkan-count 0))
	      (progn
		(skk-update-jisyo
		 skk-jisyo
		 (or word (aref skk-henkan-vector (1- skk-henkan-count))))
		(setq skk-count-kakutei (1+ skk-count-kakutei))))
	  (save-excursion
	    (goto-char (- skk-henkan-start-point skk-kanji-len))
	    (if skk-henkan-active
		(if (looking-at "")
		    (delete-char 1)
		  (message "It seems that you have deleted ."))
	      (if (looking-at "")
		  (delete-char 1)
		(message "It seems that you have deleted .")))
	    (if skk-okurigana
		(progn
		  (goto-char skk-okurigana-start-point)
		  (if (looking-at "*") (delete-char 1))
		  (setq skk-okurigana nil))))
	  (if self-insert-after-hook
	      (funcall self-insert-after-hook skk-henkan-start-point (point)))
	  (if (or overwrite-mode (boundp 'vip-ovwrt-limit))
	      (skk-del-char-with-pad
	       (skk-ovwrt-len
		;; modified by Kiyotaka Sakai, 1994.6.14.
		(string-width
		 (buffer-substring skk-henkan-start-point (point))))))
	  (setq skk-abbrev nil)))
    (setq skk-henkan-active nil
	  skk-henkan-on nil
	  skk-okurigana nil
	  skk-okuri-char ""
	  skk-henkan-key nil
	  skk-henkan-key2 nil
	  skk-henkan-okurigana nil
	  skk-henkan-vector []
	  skk-henkan-count 0
	  skk-search-key nil
	  skk-okuri-index-min 0
	  skk-okuri-index-max 0
	  skk-num-list nil)
    ;; modified by Masakazu Takahashi, 1989.8.9
    ;; modified at the suggestion of Kazuo Hirokawa, 1992.3.9.
    ;; modified by Tsugutomo Enami, 1994.7.9.
    (skk-do-auto-fill)))

;; completion

;; modified by Kiyotaka Sakai, 1994.10.5.

(defun skk-completion (first)
  (let (c-word (cont t) p)
    (if first
	(progn
	  (setq skk-completion-word
		(buffer-substring skk-henkan-start-point (point)))
	  (if (string= skk-completion-word "")
	      (error "Cannot complete an empty string!"))))
    (catch 'found
      (let ((inhibit-quit t)
	    ;; completion word is assumed to be a JIS Kanji word if it begins
	    ;; with a JIS character
	    (jis-completion-word (> (aref skk-completion-word 0) 127)))
	(save-excursion
	  (set-buffer (get-file-buffer skk-jisyo))
	  (if first (goto-char skk-okuri-nasi-min))
	  (let ((kanji-flag nil)
		(mc-flag nil))
	    ;; kanji-flag/mc-flag must be set nil for efficiency.
	    (while (re-search-forward
		    (concat "^" (regexp-quote skk-completion-word))
		    (point-max) t)
	      (if (looking-at " /")
		  nil
		(setq p (point))
		(search-forward " /")
		(setq c-word (concat skk-completion-word
				     (buffer-substring p (- (point) 2))))
		;; if the c-word begins with a JIS character, we must check
		;; if it ends with an ascii character.  if it indeed ends
		;; with an ascii character we should ignore it.
		(and jis-completion-word
		     (<= (aref c-word (1- (length c-word))) 127)
		     (setq c-word nil))
		(if c-word
		    (throw 'found c-word)))))))
      (message "No %scompletions for \"%s\""
	       (if first "" "more ") skk-completion-word)
      (ding))
    (if c-word
	(progn
	  (delete-region skk-henkan-start-point (point))
	  (insert c-word)))))

;; modified by Kazuo Hirokawa, 1991.11.18.

(defun skk-try-completion (arg)
  (interactive "P")
  (if (and skk-henkan-on (not skk-henkan-active))
      (progn
	(setq this-command 'skk-completion)
	(skk-completion
	 ;; modified at the suggestion of Kazushi Marukawa, 1992.7.22.
	 (not
	  (and skk-dabbrev-like-completion (eq last-command 'skk-completion)))))
    (skk-emulate-original-map arg)))

;; modified by Kazuo Hirokawa, 1991.11.18.

(defun skk-abbrev-period (arg)
  (interactive "P")
  (if (eq last-command 'skk-completion)
      (progn
	(setq this-command 'skk-completion)
	(skk-completion nil))
    (skk-emulate-original-map arg)))

;; modified by Kazuo Hirokawa, 1991.11.18.

(defun skk-abbrev-comma (arg)
  (interactive "P")
  (if (eq last-command 'skk-completion)
      (skk-previous-completion)
    (skk-emulate-original-map arg)))

;; added by Tsugutomo Enami, 1994.1.10.

(defun j-command-key-sequence (key command)
  "Remove initial sequence of universal arguments from KEY and return
the real key sequence that invoked COMMAND.  If COMMAND is invoked by
`execute-extended-command', nil is returned."
  (while (not (or (zerop (length key))
		  (eq command (key-binding key))))
    (setq key (substring key 1)))
  (and (not (zerop (length key))) key))

;; modified by Kazuo Hirokawa, 1991.11.18.
;; modified by Tsugutomo Enami, 1994.1.10.
;; modified by Kiyotaka Sakai, 1994.10.7.
;; modified by Tsugutomo Enami and Kiyotaka Sakai, 1994.10.17.

(defun skk-emulate-original-map (arg)
  (let ((prefix-arg arg)
	(local-map (current-local-map))
	(keys (j-command-key-sequence (this-command-keys) this-command))
	(buf (current-buffer)))
    (if (null keys)
	;; no alternative commands.  may be invoked by M-x.
	nil
      (unwind-protect
	  (progn
	    (use-local-map skk-emacs-local-map)
	    (let ((command (key-binding keys)))
	      (if (eq command this-command)
		  ;; avoid recursive calling of skk-emulate-original-map.
		  nil
		;; if no bindings are found, call `undefined'.  it's
		;; original behaviour.
		(command-execute (or command (function undefined))))))
	;; restore skk keymap.
	(save-excursion
	  (set-buffer buf)
	  (use-local-map local-map))))))

(defun skk-previous-completion ()
  (let ((inhibit-quit t)
	;; completion word is assumed to be a JIS Kanji word if it begins
	;; with a JIS character
	(jis-completion-word (> (aref skk-completion-word 0) 127))
	(c-word nil) p)
    (save-excursion
      (set-buffer (get-file-buffer skk-jisyo))
      (beginning-of-line)
      (let ((kanji-flag nil)
            (mc-flag nil) ; added by Mikio Nakajima, 1995.4.18
            (cont t))
	;; kanji-flag must be set nil for efficiency.
	(while (and cont
		    (not (bobp))
		    ;; modifed by Haru Mizuno, 1994.10.6.
		    (or (re-search-backward (concat "^" skk-completion-word)
					 skk-okuri-nasi-min t)
			(progn
			  (goto-char (point-min))
			  (looking-at (regexp-quote skk-completion-word)))))
	  (search-forward skk-completion-word)
	  (if (not (looking-at " /"))
	      (progn
		(setq p (point))
		(search-forward " /")
		(setq c-word (concat skk-completion-word
				     (buffer-substring p (- (point) 2))))
		;; if the c-word begins with a JIS character, we must check
		;; if it ends with an ascii character.  if it indeed ends
		;; with an ascii character we should ignore it.
		(if jis-completion-word
		    (if (> (aref c-word (1- (length c-word))) 127)
			(setq cont nil)
		      (setq c-word nil)
		      (beginning-of-line))
		  (setq cont nil)))
	    (beginning-of-line)))))
    (delete-region skk-henkan-start-point (point))
    (if c-word
	(insert c-word)
      (insert skk-completion-word)
      (message "No more previous completions.")
      (ding))
    (setq this-command 'skk-completion)))

(defun skk-purge-from-jisyo ()
  "Purge wrong words from jisyo buffer."
  (interactive)
  (if (and skk-henkan-active (not (string= skk-henkan-key ""))
	   (yes-or-no-p "Really purge? "))
      (progn
	(skk-update-jisyo skk-jisyo (aref skk-henkan-vector (1- skk-henkan-count)) t)
	(delete-region skk-henkan-start-point skk-henkan-end-point)
	(skk-change-marker-to-white)
	(setq skk-henkan-active nil)
	(skk-kakutei))))

;; skk server related functions
;; modified by Kiyotaka Sakai to handle multiple skk servers, 1993.7.28

(defun skk-open-server ()
  "Establish connection with skk server."
  (or (get-process "skkservd")
      (let ((succ nil))
	(if (null skk-server-list)
	    (setq skk-server-list (list (cons skk-server-host skk-serv))))
	(while (and (null succ) skk-server-list)
	  (setq skk-server-host (car (car skk-server-list))
		skk-serv (cdr (car skk-server-list))
		skk-server-list (cdr skk-server-list))
	  (get-buffer-create " *skkserv*")
	  (if (skk-open-server-subr)
	      (setq succ t)
	    (progn
	      (let ((count 7))
		(while (> count 0)
		  (message "SKK SERVER on %s is not active, I will activate it%s"
			   skk-server-host (make-string count ?.))
		  (if (string= skk-server-host (system-name))
		      ;; server host is local machine
		      (call-process skk-serv nil 0 nil)
		    (call-process
		     skk-remote-shell-program nil 0 nil skk-server-host skk-serv))
		  (sit-for 3)
		  (if (skk-open-server-subr)
		      (setq succ t
			    count 0)
		    (setq count (1- count))))))
	    (if succ
		(progn
		  (message "SKK SERVER on %s is active now." skk-server-host)
		  (sit-for 1)))))
	(if succ
	    (save-excursion
	      (if skk-mule
		  ;; this is for Mule
		  (set-process-coding-system
		   (get-process "skkservd") *euc-japan* *euc-japan*)
		;; this is for Nemacs
		;; If your Nemacs is an old one, it may not have the function
		;; set-process-kanji-code.
		(if (fboundp 'set-process-kanji-code)
		    (set-process-kanji-code (get-process "skkservd") 0))
		(set-buffer " *skkserv*")
		(setq kanji-fileio-code 0) ;; for old Nemacs
		))
	  (message "Could not activate SKK SERVER on %s." skk-server-host)
	  (sit-for 1)
	  ;; reset SKK-SERVER-HOST so as not to use server in this session
	  (setq skk-server-host nil)
	  (ding)))))

(defun skk-open-server-subr ()
  (condition-case nil
      (open-network-stream
       "skkservd" " *skkserv*" skk-server-host (or skk-portnum "skkserv"))
    (error
     nil)))

(defun skk-search-server (file limit &optional nomsg)
  "seach for henkan-key through skkserver. if server is not up, FILE is
used instead."
  ;; modified by Kiyotaka Sakai, 1993.7.28
  (if (or skk-server-list skk-server-host)
      (skk-search-server-subr file limit)
    (skk-search-jisyo-file file limit nomsg)))

(defun skk-search-server-subr (file limit)
  "search for henkan-key through skkserver and create the vector of
candidates.  if server is not available, search FILE instead."
  (let ((key (if skk-okuri-ari skk-henkan-key skk-search-key))
	(okurigana skk-henkan-okurigana) ;; passed to skk-compute-henkan-vectors
	(okuri-ari skk-okuri-ari) ;; used in skk-compute-henkan-vectors
	;; when merge-all-entry is nil, only the entry with strcitly
	;; matched okurigana is returned.
	(merge-all-entry (or (not skk-okuri-ari) (not skk-henkan-okuri-strictly)))
	(v (vector)))
    (save-excursion
      (or (process-status "skkservd") (skk-open-server))
      (if (process-status "skkservd")
	  (let ((cont t) (count 0))
	    (set-buffer " *skkserv*")
	    (erase-buffer)
	    (process-send-string "skkservd" (concat "1" key " "))
	    (while (and cont (memq (process-status "skkservd") '(open run)))
	      (accept-process-output)
	      (setq count (1+ count))
	      (if (> (buffer-size) 0)
		  (progn
		    (if (= ?1 (char-after 1))
			;; found key successfully, so check if a whole line
			;; is received.
			(if (= ?\n (char-after (1- (point-max))))
			    (setq cont nil))
		      ;; not found or error, so exit
		      (setq cont nil)))))
	    (goto-char (point-min))
	    (if skk-report-server-response
		(message "waited for server response %d times." count))
	    (if (looking-at "1")
		(progn
		  (forward-char 2)
		  (let ((l (skk-compute-henkan-vectors)))
		    (if merge-all-entry
			;; added by Tsugutomo Enami, 1994.5.30.
			(skk-vector-add (nth 0 l) (nth 2 l))
		      (nth 2 l) )))
	      ;; not found or error
	      []))
	;; server is not active, so search file instead
	(skk-search-jisyo-file file limit)))))

(defun skk-vector-add (u v)
  "Concatenate U and elements of V not in U."
    (let ((w u) (lv (length v)) (i 0))
      (while (< i lv)
	(let ((e (aref v i)))
	  (or (skk-vector-mem e u)
	      (setq w (vconcat w (vector e))))
	  (setq i (1+ i))))
      w))

(defun skk-vector-mem (e v)
  "Test if the string E is a member of the vector V."
  (let ((l (length v)) (i 0) (cont t))
    (while (and cont (< i l))
      (if (string= e (aref v i)) (setq cont nil) (setq i (1+ i))))
    (not cont)))

(defun skk-create-file (file &optional message)
  "Create an empty file named FILE if the file FILE does not exist already."
  (let ((file (expand-file-name file)))
    (or (file-exists-p file)
	(progn
	  (write-region (point-min) (point-min) file nil 0)
	  (if message
	      (progn
		(message message)
		(sit-for 3)))))))

;; patch for old Nemacs (v2)
;; suggested by Masakazu Takahashi, 1992.4.12.
;; this modification is necessary since the variable
;; self-insert-after-hook is unbound in Nemacs v2 
;
;(if skk-nemacs-v2 (setq self-insert-after-hook nil))
;
;; end of patch for old Nemacs (v2)

(provide 'skk)
